unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  uPluto2dEngine,uOpExt, LCLType, LCLIntf
  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
  private
    Engine:TPluto2DEngine;
    SpritManger:TPluto2SpriteManger;

    { private declarations }
  public
    procedure Kollision(Sprite1:TPluto2DSprite; var Sprite2:TPluto2DSprite);
    { public declarations }
  end; 

var
  Form1: TForm1; 
  Sprite, Sprite2, Sprite3, Sprite4:TPluto2DSprite;
implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Engine:=TPluto2DEngine.Create;
  Engine.AppDir:=ExtractFileDir(application.ExeName) +'/';
  Engine.ImageDir:=Engine.AppDir+'image/';
  Engine.OutCanvas:=Paintbox1.Canvas;
  Engine.SetSize(Paintbox1.Width,PaintBox1.Height);

  Engine.GameFehld.Left:=0; Engine.GameFehld.Top:=0;
  Engine.GameFehld.Right:=PaintBox1.Width;
  Engine.GameFehld.Bottom:=PaintBox1.Height;
  Engine.onCollision:=@Kollision;
// Die Datei Image.tli muss du anpassen
  Engine.ImageList.LoadXML(Engine.imageDir+'image.tlx','Grafik_Set1');
  //LoadImageListFromFile(Engine.imageDir+'image.tli');

  LoadFileToBMP(Engine.ImageDir + 'back5.png',Engine.BackupBuffer);

  SpritManger:=TPluto2SpriteManger.Create(Engine);

  Sprite:=TPluto2DSprite.Create(SpritManger);
  Sprite.id:='id002'; Sprite.LoadImage; Sprite.visible:=True;
  Sprite.Left:=100; Sprite.Top:=100;
  Sprite.DrawSprite;

  Sprite2:=TPluto2DSprite.Create(SpritManger);
  Sprite2.id:='id002'; Sprite2.LoadImage; Sprite2.visible:=True;
  Sprite2.Left:=400; Sprite2.Top:=100;
  Sprite2.DrawSprite;

  Sprite3:=TPluto2DSprite.Create(SpritManger);
  Sprite3.id:='id004'; Sprite3.LoadImage; Sprite3.visible:=True;
  Sprite3.Left:=400; Sprite3.Top:=300;
  Sprite3.DrawSprite;

  Sprite4:=TPluto2DSprite.Create(SpritManger);
  Sprite4.id:='id000'; Sprite4.LoadImage; Sprite4.visible:=True;
  Sprite4.Left:=200; Sprite4.Top:=200;
  Sprite4.DrawSprite;

  Engine.NewAllDraw;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  sp:TPluto2DSprite;
begin
  case key of
    VK_LEFT: Sprite2.left:=Sprite2.left-Sprite2.Width;
    VK_RIGHT: Sprite2.left:=Sprite2.left+Sprite2.Width;
    VK_UP: Sprite2.top:=Sprite2.top-Sprite2.Height;
    VK_DOWN: Sprite2.top:=Sprite2.top+Sprite2.Height;
  end;

  if (key in [VK_LEFT, VK_RIGHT, VK_DOWN, VK_UP]) then
    Sprite2.DrawSprite;

  sp:=SpritManger.N_Collision(sprite2.Left, Sprite2.top,Sprite2,True,True);

  if sp <> NIL then writeln('Kollision:',sp.name);
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  sp:TPluto2DSprite;
begin
  sp:=SpritManger.N_Collision(x, y);
  if sp <> NIL then writeln('Kollision:',sp.name);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  Engine.flip;
end;

procedure TForm1.Kollision(Sprite1: TPluto2DSprite;
  var Sprite2: TPluto2DSprite);
begin
  if Sprite2 <> NIL then
    writeln(Sprite2.Name)
//  else
//    writeln('Sprite2 Enthält keine Daten');
end; // TForm1.Kollision

initialization
  {$I Unit1.lrs}

end.

