{
  Autor: Michael Springwald

  Erstellt: Samstag, 06.Oktober.2007
  Updates: Montag, 22.Oktober.2007, Mittwoch, 28.November.2007
           Freitag, 07.Dezember.2007

}

unit uOpExt;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Graphics,lazbridge, opbitmapformats,RegisterLazOp,opbitmap,LCLIntf,LCLType;

  // Verößert eine TBITMap und umgeht dabei den Bug
  procedure BMPSetSize(var aBuffer:TBitMap; const aW,aH:Integer; const aFillColor:TColor = clWhite);

  // Speichert eine TBitmap in ein Bliebiges Format ab
  // Untershieden wird nach der Dateiendung
  procedure SaveBMPToFile(const aFileName:String; aBuffer:TBitMap);

  // Lädt ein Grafik Format in aBuffer.
  // Unterschieden wird nach der Dateiendung
  procedure LoadFileToBMP(const aFileName:String; Var aBuffer:TBitMap; const NoChangeSize:Boolean = False);overload;
  procedure LoadFileToBMP(const aFileName:String; Var aBuffer:TBitMap; var op:TCanvasOPBitmap);overload;

  // Erstllt auf der Angeben Grafik ein Tranzparentes Viereck
  procedure DrawTranzParentRect(aBuffer:TBItMap; const aRect:Trect; const aBrushColor:TColor; const aAlpha:Integer=100);

  procedure DrawTranzParentRectImage(aBuffer:TBitMap; aBuffer2,abuffer3,abuffer4:TBitMap; const left, top:Integer);


implementation

procedure BMPSetSize(var aBuffer:TBitMap; const aW, aH: Integer; const aFillColor:TColor = clWhite);
var
  oldY,oldH:Integer;
  oldBitMap:TBitMap;
begin
  // Kopie von Aktuellen Bild wird erstellt
  oldBitMap:=TBitMap.Create;
  oldBitMap.Width:=aBuffer.Width;
  oldBitMap.Height:=aBuffer.Height;
  oldBitMap.Canvas.Brush.color:=aFillColor;
  oldBitMap.Canvas.FillRect(0,0,oldBitMap.Width,oldBitMap.Height);
  BitBlt(oldBitMap.Canvas.Handle,0,0,oldBitMap.Width,oldBitMap.Height,aBuffer.Canvas.Handle,0,0,SRCCOPY);

  // Die Größe wird gesetzt
  aBuffer.Width:=aW;
  aBuffer.Height:=aH;
  aBuffer.Canvas.Brush.color:=aFillColor;

  // Das Bild wird Installisert(Der BUG in der LCL)
  // Nach jeder Größen Änderung muss
  // erst einmal ein FillRect gezeichnet werden
  aBuffer.Canvas.FillRect(0,0,aW,aH);

  // Das alte Bild wird zurück kopiert
  BitBlt(aBuffer.Canvas.Handle,0,0,oldBitMap.Width,oldBitMap.Height,oldBitMap.Canvas.Handle,0,0,SRCCOPY);
  oldBitMap.Free;
end;

procedure SaveBMPToFile(const aFileName: String; aBuffer: TBitMap);
var
  op:TOPPicture;
begin
  op:=TOpPicture.Create;
  AssignBitmapToOpBitmap(aBuffer,op.Bitmap);
  op.SaveToFile(aFilename);
  op.free;
end;

procedure LoadFileToBMP(const aFileName: String; var aBuffer: TBitMap; const NoChangeSize:Boolean = False);
var
  op:TOPPicture;
  tmp:TBitmap;
begin
  op:=TOpPicture.Create;
  op.LoadFromFile(aFileName);
  if NoChangeSize then begin
    tmp:=TBitMap.Create;
    AssignOpBitmapToBitmap(op.Bitmap,tmp);
    aBuffer.Canvas.Draw(0,0,tmp);
    tmp.Free;

  end
  else
    AssignOpBitmapToBitmap(op.Bitmap,aBuffer);

  op.free;
end;

procedure LoadFileToBMP(const aFileName: String; var aBuffer: TBitMap; var op: TCanvasOPBitmap);
var
  op1:TOPPicture;
begin
  op1:=TOpPicture.Create;
  op1.LoadFromFile(aFileName);
  op.Assign(op1.Bitmap);

  AssignOpBitmapToBitmap(op,aBuffer);
  op1.free;
end;

procedure DrawTranzParentRect(aBuffer: TBItMap; const aRect: Trect;
  const aBrushColor: TColor; const aAlpha:Integer=100);
var
  Hintergrund:TOPPicture;
  ah:TCanvasOPBitmap;
begin
  Hintergrund:=TOPPicture.Create;
  AssignBitmapToOpBitmap(abuffer,Hintergrund.Bitmap);

  ah:=TCanvasOPBitmap.Create;
  ah.AlphaBlend:=True;
  ah.Width:=aRect.Right; ah.Height:=arect.Bottom;
  ah.Canvas.Brush.color:=aBrushColor;
  ah.Canvas.FillRect(Rect(0,0,ah.Width,ah.Height));
  ah.SetAlpha(aAlpha);
  
  Hintergrund.Bitmap.AlphaBlend := true;
  Hintergrund.Bitmap.Canvas.Draw(aRect.left,aRect.Top, ah);
  Hintergrund.Bitmap.AlphaBlend := false;

  AssignOpBitmapToBitmap(Hintergrund.Bitmap,aBuffer);
  Hintergrund.Free; ah.Free;
end;

procedure DrawTranzParentRectImage(aBuffer:TBitMap; aBuffer2,abuffer3,abuffer4:TBitMap; const left, top:Integer);
var
  Hintergrund:TOPPicture;
  ah,b2:TCanvasOPBitmap;
begin
  Hintergrund:=TOPPicture.Create;
  AssignBitmapToOpBitmap(abuffer4,Hintergrund.Bitmap);

  b2:=TCanvasOPBitmap.Create;
  AssignBitmapToOpBitmap(abuffer,b2);


  ah:=TCanvasOPBitmap.Create;
//  ah.AlphaBlend:=True;
  ah.Width:=abuffer.Width; ah.Height:=abuffer.Height;
  ah.Canvas.Brush.Color:=clWhite;
  ah.Transparent:=True;
  ah.TransparentColor:=clWhite;

  ah.Canvas.Draw(left,top,b2);

  Hintergrund.Bitmap.Transparent:=True;
  Hintergrund.Bitmap.TransparentColor:=clWhite;

  Hintergrund.Bitmap.Canvas.Draw(left,Top, ah);

  AssignOpBitmapToBitmap(Hintergrund.Bitmap,aBuffer3);
  Hintergrund.Free; ah.Free; b2.free;
end;
end.

