{
  Autor: Michael Springwald

  Erstellt: Montag, 19.November.2007

  Updates:
-------------------------------------------------------------------
01 | Mittwoch, 21.November.2007    | Donnerstag, 22.November.2007 |
-------------------------------------------------------------------
02 | Freitag, 23.November.2007     | Samstag, 24.November.2007    |
-------------------------------------------------------------------
03 | Sontag, 25.November.2007      | Mittwoch, 28.November.2007   |
-------------------------------------------------------------------
04 | Donnerstag, 29.Novmeber.2007  | Freitag, 30.November.2007    |
-------------------------------------------------------------------
05 | Montag, 03.Dezember.2007      | Freitag, 07.Dezember.2007    |
-------------------------------------------------------------------
06 | Sontag, 09.Dezember.2007      | Montag, 10.Dezember.2007     |
-------------------------------------------------------------------
07 | Dienstag, 11.Dezember.2007    | Sonntag, 23.Dezember.2007    |
-------------------------------------------------------------------
08 | Montag, 24.Dezember.2007      | Mittwoch, 25.Dezember.2007   |
-------------------------------------------------------------------
09 | Donnerstag, 27.Dezmber.2007   | Freitag, 28.Dezember.2007    |
-------------------------------------------------------------------
10 | Samstag, 29.Dezmber.2007      | Montag, 31.Dezember.2007     |
-------------------------------------------------------------------
11 | Montag, 31.Dezember.2007      | Samstag, 05.Janur.2008       |
-------------------------------------------------------------------
12 | Sontag, 06.Januer.2008        | Montag, 07.Janur.2008        |
-------------------------------------------------------------------
13 | Freitag, 11.Janur.2008        | Montag, 14.Janur.2008        |
-------------------------------------------------------------------
14 | Montag, 21.Janur.2008         | Freitag, 25.Janur.2008       |
-------------------------------------------------------------------
15 | Sontag, 27.Janur.2008         | Donnerstag, 31.Janur.2008    |
-------------------------------------------------------------------
16 | Freitag, 01.Febura.2008       | Freitag, 08.Febura.2008      |
-------------------------------------------------------------------
17 | Samstag, 16.Febura.2008       | Freitag, 22.Febura.2008      |
-------------------------------------------------------------------
18 | Montag, 25.Febura.2008        |                              |
-------------------------------------------------------------------
19 |                               |                              |
-------------------------------------------------------------------
20 |                               |                              |
-------------------------------------------------------------------
21 |                               |                              |
-------------------------------------------------------------------
22 |                               |                              |
-------------------------------------------------------------------



}

unit uPluto2dEngine;

{$mode objfpc}{$H+}

interface

// ----------------------------------------------
uses
  opbitmap,Classes, SysUtils, Graphics, LCLIntf, LCLType, uOpExt, uPlutoImageList,
  contnrs, uplutogamemenu,FPImage,GraphType,IntfGraphics,LResources,lazbridge, opbitmapformats,RegisterLazOp;
// ----------------------------------------------

type
// ----------------------------------------------
  TPluto2SpriteManger = class; TPluto2DEngine = class;
  TPluto2DSprite      = class;


  { TPluto2DSpriteList }
  TPluto2DSpriteList = class(TObjectList)
    function GetItems(index: Integer): TPluto2DSprite;
  private

  protected

  public
    property SpriteList[index:Integer]:TPluto2DSprite read GetItems;

    constructor Create;
    destructor Destroy; override;
  published

  end; // TPluto2DSpriteList

  { TPluto2DCollisionItem }
  TPluto2DCollisionItem = class
  private

  protected

  public
    Enabled:Boolean;
    GUID:String;
    Kompo:TPluto2DSprite;

    constructor Create;
    destructor Destroy; override;
  published

  end; // TPluto2DCollisionItem
  
// ----------------------------------------------
// Ein Displayitem wird beschrieben
// TPluto2DEngineDisPlayItem
// ----------------------------------------------

  TPluto2DEngineDisPlayItem = class
    fgColor, bgColor, pColor:TColor;
    Left, Top, Width, Height:Integer;
    Text:String;
    constructor Create;
  end; // TPluto2DEngineDisPlayItem
// ----------------------------------------------


// ----------------------------------------------
// Ereignisse                                   -
  { Wird beim zeichnen von einem Srpite ausgelöst
    Wird von der 2D Engine aufgefangen und weiter geleitet
    an den Jeweiligen SpriteManger
  }
  TPlutoOnDraw = procedure (Sprite:TPluto2DSprite) of Object;

  {
    Wird ausgelöst sobald eine Kollision stattgefunden hat
  }
  TPlutoOnCollision = procedure (Sprite1:TPluto2DSprite; var Sprite2:TPluto2DSprite) of Object;

// ----------------------------------------------

// ----------------------------------------------
// TPluto2DSprite                               -
// ----------------------------------------------
  TPluto2DSprite = class
    fParent2: TPluto2DSprite;
    fAutoDrawLoadID: Boolean;
  private
    ox,oy,ow,oh:Integer;
  protected
    fName, fID, fTyp, fZusatzt, fBeschreibung:String;
    fLeft, fTop, fWidth, fHeight, fTag:Integer;
    fVisible, fNoCollision, fAutoLoadID:Boolean;
    function GetTag: Integer; Virtual;
    function GetBeschreibung: String; Virtual;
    function GetID: string; Virtual;
    function GetName: String; Virtual;
    function GetNoCollision: Boolean; Virtual;
    function GetRec(Index: integer): integer; Virtual;
    function GetTyp: String; Virtual;
    function GetVisible: Boolean; Virtual;
    function GetZusatzt: String; Virtual;
    function GetAutoDrawLoadID: Boolean; Virtual;
    function GetAutoLoadId: Boolean; Virtual;

//    procedure SetParant(const AValue: TPluto2DSprite); Virtual;
    procedure SetTag(const AValue: Integer); Virtual;
    procedure SetAutoDrawLoadID(const AValue: Boolean); Virtual;
    procedure SetAutoLoadID(const AValue: Boolean); Virtual;
    procedure SetBeschreibung(const AValue: String); Virtual;
    procedure SetID(const AValue: string); Virtual;
    procedure SetName(const AValue: String); Virtual;
    procedure SetNoCollision(const AValue: Boolean); Virtual;
    procedure SetParent2(AValue: TPluto2DSprite); Virtual;
    procedure SetRect(Index: integer; const AValue: integer); Virtual;
    procedure SetTyp(const AValue: String); Virtual;
    procedure SetVisible(const AValue: Boolean); Virtual;
    procedure SetZusatzt(const AValue: String); Virtual;
  public
    // Ein Dummy Object was dem Sprite zugewiesen werden kann
    // Es ist beim Erstellen des Sprite auf nil gesetzt
    Data:TObject;
    {
      Wenn diesem Sprite weitere
    }
    
    property Parent2:TPluto2DSprite read fParent2 write SetParent2;

    // Damit der Sprit zugrief auf einige Variabeln hat
    // wie z.b. den Canvas und den Backupbuffer
    SpriteMager:TPluto2SpriteManger;
    {
      Alle Sprite gehören den Sprite. D.h. der
      Sprit ist selber auch ein Kontener.
      
      Hier sind alle seine "Kinder" Enhalten
    }
    SpriteMager2:TPluto2SpriteManger;
    isBackup:Boolean;

    {
      Muss vom Spritemanger gesetzt werden
      Der Canvas, wo drauf gezeichnet wird, z.b.
      einer PaintBox
    }
    OutCanvas:TCanvas;
    Buffer, BackupBuffer:TBitMap;
    ImageList:TPlutoImageList;

    // Das bild was dieses Sprite da stellen soll.
    SpriteImage:TBitMap;
    guid:String;

    // Muss vom User gesetzt werden
    mainParent:TPluto2DSprite;
    kx,ky:Integer;
    Parent2Visible:Boolean;
    Parent:TPluto2DSprite;
    SpBackup:TBitMap;
    // Jeder Sprite gehört ist in einem Sprite Manger drin
    constructor Create(aSpriteManger:TPluto2SpriteManger);Virtual; overload;
    
    // Wenn Ein Sprite unter Sprite also Kinder haben soll
    // Muss dieser verwendet werden
    constructor Create(achildSprite:TPluto2DSprite);Virtual; overload;

    // Zerstört den Sprite und löscht ihn auch wieder aus dem Spritmanger
    destructor Destroy; override;

    {
      Kopiert alle Wichtigen Eigenschaften von aSprite
    }
    procedure Assign(var aSprite:TPluto2DSprite);

    // Sucht die Angaben ID und läd das Bild in den Buffer
    procedure LoadImage;

    {
      Zeichnet das Sprite, bei event False wird kein Event ausgelöst
      was die Engine Wieder auffängt, und alle sprite neu zeichnet,
      die im angaben bereich zu finden sind.
    }
    
    procedure DrawSprite(const  event:Boolean = True; const NewDraw:Boolean = True) ;Overload;

    procedure BackupImage;
    procedure BackupToImage;
    function GetR(const nx:Integer = 0; const ny:Integer = 0; const nw:Integer = 0; const nh:Integer = 0):TRect;
  published
    {
      Die ID Solle nur einmal vorkommen.
      Mit Hilfe der ID kann die Procedure LoadImage das richtige Objekt
      finden wenn es in der ImageListe eins gibt
    }
    property Id:string read GetID write SetID;
    {
      Aber hier wird intern nix mehr verwendet
    }
    property Name:String read GetName write SetName;
    property Typ:String read GetTyp write SetTyp;
    property Zusatzt:String read GetZusatzt write SetZusatzt;
    property Beschreibung:String read GetBeschreibung write SetBeschreibung;

    {
      Left, Top sind wichtig für die Positions Angabe
      Width und Height für die Größe
    }
    property Left:integer index 0 read GetRec write SetRect;
    property Top:integer index 1 read GetRec write SetRect;
    property Width:integer index 2 read GetRec write SetRect;
    property Height:integer index 3 read GetRec write SetRect;
    
    property Tag:Integer read GetTag write SetTag;

    // Wenn beim Sprite Manger Collision aufgerufen wird
    // Wird dieser Sprite ausgelassen wenn er auf Flse steht
    property NoCollision:Boolean read GetNoCollision write SetNoCollision;
    {
      Besimmt ob ein Sprite Angezeigt werden soll oder nicht
    }
    property Visible:Boolean read GetVisible write SetVisible;
    // Lädt Autmatisch die ID sobald die Eigenschaft ID gesetzt wird
    property AutoLoadID:Boolean read GetAutoLoadId write SetAutoLoadID;
    // Zeichnet die ID auch Automaitsch sobald sie geladen ist
    property AutoDrawLoadID:Boolean read GetAutoDrawLoadID write SetAutoDrawLoadID;
 //   property Parent:TPluto2DSprite read GetParent write SetParant;
  end; // TPluto2DSprite
  
// ----------------------------------------------
// TPluto2SpriteManger                          -
// ----------------------------------------------
  TPluto2SpriteManger  = class
    function GetSprite(index: Integer): TPluto2DSprite;
    function GetCollisionItems(index: Integer): TPluto2DCollisionItem;
  private
  protected

  public
    Start:Boolean;
    property Items[index:Integer]:TPluto2DSprite read GetSprite;
    property CollisionItem[index:Integer]:TPluto2DCollisionItem read GetCollisionItems;

    fVisibleList:TPluto2DSpriteList;
    fUsedVisibleList:Boolean;

    CollisionsItems:TObjectList;
    Engine:TPluto2DEngine;
    fItems:TObjectList;
    fOnDraw:TPlutoOnDraw;
    onCollision:TPlutoOnCollision;
    // Muss von TPluto2DEngine gesetzt werden
    OutCanvas:TCanvas;
    Buffer, BackupBuffer:TBitMap;
    ImageList:TPlutoImageList;

    constructor Create(Pluto2DEngine:TPluto2DEngine; const aUsedVisibleList:Boolean = False);
    destructor Destroy;

    function AddCollisionItems(const aSprite:TPluto2DSprite):Integer;
    
    // Gibt alle Änderungen auf dem Bildschrim aus
    procedure flip;
    procedure DrawAllSprite(Sprite:TPluto2DSprite);

    // Übernimt alle Wichtigen Eigenschaften vom aSpriteManger
    procedure Assign(aSpriteManger:TPluto2SpriteManger);

    // Löst das Ereigniss onCollision aus
    procedure CheckCollision;overload;

    // Löst das Ereigniss onCollision aus
    procedure CheckCollision(Sprite:TPluto2DSprite;const px,py:Integer);overload;

    // Löst das Ereigniss onCollision aus
    procedure CheckCollision(const ax,ay:Integer);
    
    function GetCollision(const ax,ay:Integer; sprite:TPluto2DSprite):Integer;
    function FindCollisionItem(const aString:String; const aFindSpritManger:Boolean = False):Integer;
    
    { Neue Kollisionen Funktionen benutzten "Pixel Check"
      ax, ay     : Sind Positions Angaben, um das Sprite rauszusuchen.
                   z.b. Maus Positonen.
      aEvent     : Ob das Kollisions Event ausgelöst werden soll
      aPixelCheck: Ob Pixel Check ausgelöst werden soll
      
      Rückgabe wert ist das Sprite mit dem es Koledirt ist
    }
    function N_Collision(const ax, ay:Integer; const aEvent:Boolean=True; const aPixelcheck:boolean = True):TPluto2DSprite;overload;
    {
      aSprite:TPluto2DSprite: Der Sprite wird ausgelassen
      ax, ay                : Positions Angaben
    }
    
    function N_Collision(const ax, ay:Integer; const aSprite:TPluto2DSprite; const aEvent:Boolean=True; const aPixelcheck:boolean = True):TPluto2DSprite;overload;

    function N_GetCollision(const ax, ay:Integer; const aSpriteList:TPluto2DSpriteList):TPluto2DSprite; overload;

  published
  end; // TPluto2SpriteManger

// ----------------------------------------------
// TPluto2DEngine                               -
// ----------------------------------------------
  TPluto2DEngine = class
  private
    fDisPlayList:TObjectList;
    function GetDisPlayitems(index: Integer): TPluto2DEngineDisPlayItem;
  protected

  public
    only:Boolean;
    b2:TCanvasOPBitmap;
    // Einige Standard Verzeichnisse
    AppDir, ImageDir:String;
    
    // Wenn es Menus Im Spiel gibt, sollten sie hier rein
    GameMenu:TPlutoGameMenu;
    
    // Enhält das Spiel Fehld als TRect
    GameFehld:TRect;
    // Enthält alle Manger die Geladen wurden
    SpriteMangerList:TObjectList;
    // Stellt ein ImageList zu verfügung
    ImageList:TPlutoImageList;
    // Muss vom User angeben werden
    OutCanvas:TCanvas;
    // Wird Automatisch gesetzt
    Buffer, BackupBuffer:TBitMap;

    // Wird von einem Sprite Manger ausgelöst, wenn es eine
    // oder mehrer Kollisionen geben hat
    onCollision:TPlutoOnCollision;
    LevelBegin:Integer;
    
    // Enhält eine Liste von allen Level einer Mission
    LevelMissionen:TStringlist;
    // Enhält den Index des Aktullen Levels in der Mission
    LevelIndex:Integer;
    
    // Enhält eine Liste alle Verfügbaren Hintergrund Bilder.
    BackgrundList:TStringList;
    
    // Enhält alle Hintergreunde für den Display
    DisplayList:TStringlist;
    
    // Für die Seiten leiste die Hinterreunde
    SeitenLeisteList:TStringlist;
    
    property DisPlayitems[index:Integer]:TPluto2DEngineDisPlayItem read GetDisPlayitems;

    constructor Create;
    destructor Destroy; override;

    // Fügt ein Displayitem zu der liste
    procedure AddDisPlayitem(const aCaption:String; const afgColor, abgColor,apColor:TColor; const aLeft, aTop, aWidth, aHeight:Integer);
    
    // Zeichnet alle Einträge aus der Displayitems Liste
    procedure DrawDisPlayItems;
    
    // Zeichnet einen gezielten eintrag neu
    procedure DrawDisplayItem(const aIndex:Integer);

    // Setzt Buffer, BackuBuffer und OutCanvas für einen Spritemanger
    procedure RegSpriteManger(var SpriteManger:TPluto2SpriteManger);
    // Zeichnet jeden Sprite im Buffer neu und gibt dann alles aus
    procedure NewAllDraw;
    // Gibt Buffer auf OutCanvas aus
    procedure flip;
    // Setzt Buffer, BackuBuffer und OutCanvas für einen Sprite
    procedure ReSprite(var Sprite:TPluto2DSprite);
    procedure SetSize(const aw, ah:Integer);
    procedure DrawSprits(Sprite:TPluto2DSprite);
    procedure CheckCollision;
    procedure CheckCollision(sprite:TPluto2DSprite; const px,py:Integer);overload;
    procedure CheckCollision(const ax,ay:Integer);overload;
    function GetCollision(const ax,ay:Integer;sprite:TPluto2DSprite):Integer;
    procedure LoadMissionFile(const aFile:String);
  published
  end; // TPluto2DEngine
  function kollision(r1,r2:TRect;B1,b2:TBitMap):boolean;
  
var
  fVisibleList:TPluto2DSpriteList;
implementation

{
  Autor: umpani, Michael Springwald
  Update:
  Freitag den 25.Janur.2008, Freitag, 01.Febura.2008

  Diese Funktion stammt von "umpani" und ist hier zu finden:
  http://www.delphi-forum.de/viewtopic.php?t=12746&postdays=0&postorder=asc&start=20

  Ich habe sie "nur" Angepasst für mein zweck. Fragen also bitte an
  "umpani" richten im delphi-forum.de.
}

function kollision(r1,r2:TRect;B1,b2:TBitMap):boolean;
var
  ueberlapp_breite, ueberlapp_hoehe:integer;
  ueberlapp_nr1_x, ueberlapp_nr1_y, ueberlapp_nr2_x, ueberlapp_nr2_y:integer;
  x,y:integer;
  farbenr1,farbenr2:TColor;
  z:Boolean;
begin
  z:=False;
  if r1.left < r2.left then
    ueberlapp_breite := (r1.left + r1.Right) - (r2.left)
  else
    ueberlapp_breite := (r2.left + r2.Right) - r1.Left;

  if r1.Right > r2.Right then if ueberlapp_breite >= r2.Right then ueberlapp_breite := r2.Right;

  if r1.top < r2.top then
     ueberlapp_hoehe := (r1.Top + r1.Bottom) - (r2.Top)
   else
     ueberlapp_hoehe := (r2.Top + r2.Bottom) - (r1.Top);

  if r1.Bottom > r2.Bottom then if ueberlapp_hoehe > r2.Bottom then ueberlapp_hoehe := r2.Bottom;

  if (ueberlapp_breite > 0) and (ueberlapp_hoehe > 0) then begin
    if r1.Right >= r2.Right then begin
      if (r2.Left+r2.Right) >= (r1.Left+r1.Right) then begin
        ueberlapp_nr1_x := r1.Right - ueberlapp_breite;
        ueberlapp_nr2_x := 0;
      end;

      if ((r2.Left+r2.Right) < (r1.Left+r1.Right)) and (r2.left >= r1.left) then begin
        ueberlapp_nr1_x := (r2.Left-r1.Left);
        ueberlapp_nr2_x := 0;
      end;

      if (r2.Left) < (r1.Left) then begin
        ueberlapp_nr1_x := 0;
        ueberlapp_nr2_x := r2.Right - ueberlapp_breite;
      end;
    end;
  end;

  if r1.Right < r2.Right then begin
    if (r1.Left+r1.Right) >= (r2.Left+r2.Right) then begin
      ueberlapp_nr2_x := r2.Right - ueberlapp_breite;
      ueberlapp_nr1_x := 0;
    end;

    if ((r1.Left+r1.Right) < (r2.Left+r2.Right)) and (r1.Left >= r2.Left) then begin
      ueberlapp_nr2_x := (r1.Left-r2.Left);
      ueberlapp_nr1_x := 0;
    end;

    if (r1.Left < r2.Left) then begin
      ueberlapp_nr2_x := 0;
      ueberlapp_nr1_x := r1.Right - ueberlapp_breite;
    end;
  end;

  if r1.Bottom >= r2.Bottom then begin
    if (r2.Top+r2.Bottom) >= (r1.Top+r1.Bottom) then begin
      ueberlapp_nr1_y := r1.Bottom - ueberlapp_hoehe;
      ueberlapp_nr2_y := 0;
    end;

    if ((r2.Top+r2.Bottom) < (r1.top+r1.Bottom)) and (r2.Top >= r1.Top) then begin
      ueberlapp_nr1_y := (r2.top-r1.top);
      ueberlapp_nr2_y := 0;
    end;

    if (r2.top) < (r1.top) then begin
      ueberlapp_nr1_y := 0;
      ueberlapp_nr2_y := r2.Bottom - ueberlapp_hoehe;
    end;
  end;

  if r1.Bottom < r2.Bottom then begin
    if (r1.Top+r1.Bottom) >= (r2.Top+r2.Bottom) then begin
      ueberlapp_nr2_y := r2.Bottom - ueberlapp_hoehe;
      ueberlapp_nr1_y := 0;
    end;

    if ((r1.Top+r1.Bottom) < (r2.Top+r2.Bottom)) and (r1.Top >= r2.Top) then begin
      ueberlapp_nr2_y := (r1.top-r2.top);
      ueberlapp_nr1_y := 0;
    end;

    if (r1.top < r2.top) then begin
      ueberlapp_nr2_y := 0;
      ueberlapp_nr1_y := r1.Bottom - ueberlapp_hoehe;
    end;
  end;

  for x := 0 to (ueberlapp_breite-1) div 2 do begin
    for y := 0 to (ueberlapp_hoehe -1) div 2 do begin
      farbenr1 :=B1.Canvas.Pixels[ueberlapp_nr1_x+x*2,ueberlapp_nr1_y+y*2];
      farbenr2 :=B2.Canvas.Pixels[ueberlapp_nr2_x+x*2,ueberlapp_nr2_y+y*2];
      if ( farbenr1 <> b1.TransparentColor) and (farbenr2 <> b2.TransparentColor) then begin
        result:=True;
        exit;
      end;
    end; // for y
  end; // for x
  result:=False;
end; // kollision

function RandomID2A(count:Integer):widestring;
const
  noChar = ':\-._';
  abc1    = 'abcdefghijklmnopqrstuvwxyz';
  abc2    = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
  Zahlen  = '0123456789';
var
  x,len:Integer;
  s:widestring;
  i:Byte;
  z:widestring;
  str:widestring;
begin
  s:='';z:='';
  str:=abc1+abc2+Zahlen;
  len:=Length(str);

  for x:=1 to count do begin
    i:=random(len)+1;
    z:=str[i];

    if Pos(z,noChar) > 0 then begin
      repeat
        i:=random(len)+1;
        z:=str[i];
      until Pos(z,noChar) = 0;
    end;
    if z <> '' then
    s:=s + z;
  end;
  result:=s;
end; // RandomID2A

function RandomGUI:widestring;
begin
  result:='{'+RandomID2A(8)+'-'+RandomID2A(4)+'-'+RandomID2A(4)+'-'+RandomID2A(4)+'-'+RandomID2A(12)+'}'
end; // RandomGUI:widestring

procedure DrawTransparentBitmap(DC: HDC; hBmp : HBITMAP ;
          xStart: integer; yStart : integer; cTransparentColor : COLORREF);
var
      bm:                                                  BITMAP;
      cColor:                                              COLORREF;
      bmAndBack, bmAndObject, bmAndMem, bmSave:            HBITMAP;
      bmBackOld, bmObjectOld, bmMemOld, bmSaveOld:         HBITMAP;
      hdcMem, hdcBack, hdcObject, hdcTemp, hdcSave:        HDC;
      ptSize:                                              TPOINT;

begin
   hdcTemp := CreateCompatibleDC(dc);
   SelectObject(hdcTemp, hBmp);   // Select the bitmap

   GetObject(hBmp, sizeof(BITMAP), @bm);
   ptSize.x := bm.bmWidth;            // Get width of bitmap
   ptSize.y := bm.bmHeight;           // Get height of bitmap
   DPtoLP(hdcTemp, ptSize, 1);        // Convert from device
                                      // to logical points

   // Create some DCs to hold temporary data.
   hdcBack   := CreateCompatibleDC(dc);
   hdcObject := CreateCompatibleDC(dc);
   hdcMem    := CreateCompatibleDC(dc);
   hdcSave   := CreateCompatibleDC(dc);

   // Create a bitmap for each DC. DCs are required for a number of
   // GDI functions.

   // Monochrome DC
   bmAndBack   := CreateBitmap(ptSize.x, ptSize.y, 1, 1, nil);

   // Monochrome DC
   bmAndObject := CreateBitmap(ptSize.x, ptSize.y, 1, 1, nil);

   bmAndMem    := CreateCompatibleBitmap(dc, ptSize.x, ptSize.y);
   bmSave      := CreateCompatibleBitmap(dc, ptSize.x, ptSize.y);

   // Each DC must select a bitmap object to store pixel data.
   bmBackOld   := SelectObject(hdcBack, bmAndBack);
   bmObjectOld := SelectObject(hdcObject, bmAndObject);
   bmMemOld    := SelectObject(hdcMem, bmAndMem);
   bmSaveOld   := SelectObject(hdcSave, bmSave);

   // Set proper mapping mode.
//   SetMapMode(hdcTemp, GetMapMode(dc));

   // Save the bitmap sent here, because it will be overwritten.
   BitBlt(hdcSave, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0, SRCCOPY);

   // Set the background color of the source DC to the color.
   // contained in the parts of the bitmap that should be transparent
   cColor := SetBkColor(hdcTemp, cTransparentColor);

   // Create the object mask for the bitmap by performing a BitBlt
   // from the source bitmap to a monochrome bitmap.
   BitBlt(hdcObject, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0,
          SRCCOPY);

   // Set the background color of the source DC back to the original
   // color.
   SetBkColor(hdcTemp, cColor);

   // Create the inverse of the object mask.
   BitBlt(hdcBack, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0,
          NOTSRCCOPY);

   // Copy the background of the main DC to the destination.
   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, dc, xStart, yStart,
          SRCCOPY);

   // Mask out the places where the bitmap will be placed.
   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0, SRCAND);

   // Mask out the transparent colored pixels on the bitmap.
   BitBlt(hdcTemp, 0, 0, ptSize.x, ptSize.y, hdcBack, 0, 0, SRCAND);

   // XOR the bitmap with the background on the destination DC.
   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0, SRCPAINT);

   // Copy the destination to the screen.
   BitBlt(dc, xStart, yStart, ptSize.x, ptSize.y, hdcMem, 0, 0,
          SRCCOPY);

   // Place the original bitmap back into the bitmap sent here.
   BitBlt(hdcTemp, 0, 0, ptSize.x, ptSize.y, hdcSave, 0, 0, SRCCOPY);

   // Delete the memory bitmaps.
   DeleteObject(SelectObject(hdcBack, bmBackOld));
   DeleteObject(SelectObject(hdcObject, bmObjectOld));
   DeleteObject(SelectObject(hdcMem, bmMemOld));
   DeleteObject(SelectObject(hdcSave, bmSaveOld));

   // Delete the memory DCs.
   DeleteDC(hdcMem);
   DeleteDC(hdcBack);
   DeleteDC(hdcObject);
   DeleteDC(hdcSave);
   DeleteDC(hdcTemp);
end;

// ----------------------------------------------
// ----------------------------------------------
procedure TPluto2DEngine.RegSpriteManger(
  var SpriteManger: TPluto2SpriteManger);
begin
  SpriteManger.OutCanvas:=OutCanvas;
  SpriteManger.Buffer:=buffer;
  SpriteManger.BackupBuffer:=BackupBuffer;
  SpriteManger.ImageList:=ImageList;
end;// RegSpriteManger

procedure TPluto2DEngine.NewAllDraw;
var
  px,py,pw,ph:Integer;
  x,y:Integer;
begin
  Buffer.Canvas.Draw(0,0,BackupBuffer);
  for y:=0 to SpriteMangerList.Count-1 do begin
    for x:=0 to TPluto2SpriteManger(SpriteMangerList[y]).fItems.Count-1 do begin
//      if TPluto2DSprite(TPluto2SpriteManger(SpriteMangerList[y]).fItems[x]).Visible then
        TPluto2DSprite(TPluto2SpriteManger(SpriteMangerList[y]).fItems[x]).DrawSprite(False);
    end; // for x
  end; // for y
  flip
end;

procedure TPluto2DEngine.flip;
begin
  OutCanvas.Draw(0,0,buffer);
end; // TPluto2SpriteManger.flip

procedure TPluto2DEngine.ReSprite(var Sprite: TPluto2DSprite);
begin
  Sprite.OutCanvas:=OutCanvas;
  Sprite.Buffer:=buffer;
  Sprite.BackupBuffer:=BackupBuffer;
end; // TPluto2DEngine.ReSprite

procedure TPluto2DEngine.SetSize(const aw, ah: Integer);
begin
  Buffer.Width:=aw; Buffer.Height:=ah;
  Buffer.Canvas.Brush.color:=clWhite;
  Buffer.Canvas.FillRect(0,0,aw,ah);

  BackupBuffer.Width:=aw; BackupBuffer.Height:=ah;
  BackupBuffer.Canvas.Brush.color:=clWhite;
  BackupBuffer.Canvas.FillRect(0,0,aw,ah);

end; // TPluto2DEngine.SetSize

function TPluto2DEngine.GetDisPlayitems(
  index: Integer): TPluto2DEngineDisPlayItem;
begin
  result:=TPluto2DEngineDisPlayItem(fDisPlayList[index]);
end;

// ----------------------------------------------
// TPluto2DEngine                               -
// ----------------------------------------------
constructor TPluto2DEngine.Create;
begin
  inherited Create;
  fDisPlayList:=TObjectList.Create;
  only:=False;
  b2:=TCanvasOPBitmap.Create;
  b2.TransparentColor:=clwhite;
  SpriteMangerList:=TObjectList.Create;
  Buffer:=TBitMap.Create; BackupBuffer:=TBitMap.Create;
  ImageList:=TPlutoImageList.Create;
  LevelMissionen:=TStringlist.Create;
  LevelIndex:=0; GameMenu:=TPlutoGameMenu.Create;
  GameMenu.Buffer:=Buffer;
  BackgrundList:=TStringList.Create; DisplayList:=TStringlist.Create;
  SeitenLeisteList:=TStringlist.Create;
end; // TPluto2DEngine.Create

destructor TPluto2DEngine.Destroy;
begin
  FreeAndNil(ImageList);

  FreeAndNil(Buffer); FreeAndNil(BackupBuffer);
  FreeAndNil(SeitenLeisteList); FreeAndNil(DisplayList);
  FreeAndNil(BackgrundList); FreeAndNil(fDisPlayList);

  inherited Destroy;
end; // TPluto2DEngine.Destroy

procedure TPluto2DEngine.AddDisPlayitem(const aCaption: String; const afgColor,
  abgColor, apColor: TColor; const aLeft, aTop, aWidth, aHeight: Integer);
var
  DisPlayItem:TPluto2DEngineDisPlayItem;
begin
  DisPlayItem:=TPluto2DEngineDisPlayItem.Create;
  DisPlayItem.Text:=aCaption;
  
  DisPlayItem.fgColor:=afgColor;
  DisPlayItem.bgColor:=abgColor;
  DisPlayItem.pColor:=apColor;

  DisPlayItem.Left:=aLeft;
  DisPlayItem.Top:=aTop;
  DisPlayItem.Width:=aWidth;
  DisPlayItem.Height:=aHeight;

  fDisPlayList.Add(DisPlayItem);
end;

procedure TPluto2DEngine.DrawDisPlayItems;
var
  px, py, pw, ph, i:Integer;
begin
  px:=0; py:=0; pw:=0; ph:=0;
  
  for i:=0 to fDisPlayList.count-1 do begin
    px:=DisPlayitems[i].Left;
    py:=400+DisPlayitems[i].top;

    if DisPlayitems[i].Width = 0 then
      pw:=Buffer.Canvas.TextWidth(DisPlayitems[i].Text)
    else
      pw:=DisPlayitems[i].Width;
      
    if DisPlayitems[i].Height = 0 then
      ph:=Buffer.Canvas.TextHeight(DisPlayitems[i].Text)+5
    else
      ph:=DisPlayitems[i].Height;
    
    Buffer.Canvas.Brush.color:=DisPlayitems[i].bgColor;
    Buffer.Canvas.Pen.color:=DisPlayitems[i].pColor;
    Buffer.Canvas.Font.color:=DisPlayitems[i].fgColor;

    Buffer.Canvas.FillRect(px,py,px+pw,py+ph);
    Buffer.Canvas.TextOut(px,py,DisPlayitems[i].Text);
  end; // for i
  
end; // TPluto2DEngine.DrawDisPlayItems

procedure TPluto2DEngine.DrawDisplayItem(const aIndex: Integer);
var
  px, py, pw, ph:Integer;
begin
  px:=DisPlayitems[aIndex].Left;
  py:=400+DisPlayitems[aIndex].top;

  if DisPlayitems[aIndex].Width = 0 then
    pw:=Buffer.Canvas.TextWidth(DisPlayitems[aIndex].Text)
  else
    pw:=DisPlayitems[aIndex].Width;

  if DisPlayitems[aIndex].Height = 0 then
    ph:=Buffer.Canvas.TextHeight(DisPlayitems[aIndex].Text)+5
  else
    ph:=DisPlayitems[aIndex].Height;

  Buffer.Canvas.Brush.color:=DisPlayitems[aIndex].bgColor;
  Buffer.Canvas.Pen.color:=DisPlayitems[aIndex].pColor;
  Buffer.Canvas.Font.color:=DisPlayitems[aIndex].fgColor;

  BitBlt(buffer.canvas.Handle,px,py,pw,ph,BackupBuffer.Canvas.Handle, px, py,SRCCOPY);

  Buffer.Canvas.FillRect(px,py,px+pw,py+ph);
  Buffer.Canvas.TextOut(px,py,DisPlayitems[aindex].Text);
  BitBlt(OutCanvas.Handle,px,py,pw,ph,buffer.Canvas.Handle, px, py,SRCCOPY);

end; // TPluto2DEngine.DrawDisplayItem

procedure TPluto2DEngine.DrawSprits(Sprite: TPluto2DSprite);
var
  i:Integer;
begin
  for i:=0 to SpriteMangerList.Count-1 do
    TPluto2SpriteManger(SpriteMangerList[i]).DrawAllSprite(Sprite);
end;

procedure TPluto2DEngine.CheckCollision;
var
  i:Integer;
begin
  for i:=0 to SpriteMangerList.Count-1 do
    TPluto2SpriteManger(SpriteMangerList[i]).CheckCollision
end; // TPluto2DEngine.CheckCollision

procedure TPluto2DEngine.CheckCollision(sprite: TPluto2DSprite; const px,py:Integer);
var
  i:Integer;
begin
  for i:=0 to SpriteMangerList.Count-1 do
    TPluto2SpriteManger(SpriteMangerList[i]).CheckCollision(sprite,px,py);
end;

procedure TPluto2DEngine.CheckCollision(const ax, ay: Integer);
var
  i:Integer;
begin
  for i:=0 to SpriteMangerList.Count-1 do
    TPluto2SpriteManger(SpriteMangerList[i]).CheckCollision(ax,ay);
end;

function TPluto2DEngine.GetCollision(const ax, ay: Integer;sprite:TPluto2DSprite): Integer;
var
  i,z,t:Integer;
begin
  z:=-1;
  for i:=0 to SpriteMangerList.Count-1 do begin
    t:=TPluto2SpriteManger(SpriteMangerList[i]).GetCollision(ax,ay,sprite);
    if t > -1 then z:=t;
  end;

  result:=t;
end;

procedure TPluto2DEngine.LoadMissionFile(const aFile: String);
begin
  if FileExists(aFile+'missionen.txt') then begin
    LevelMissionen.LoadFromFile(aFile+'missionen.txt');
   // LevelBegin:=LevelMissionen.IndexOf('>');
  end;
end;

function TPluto2SpriteManger.GetSprite(index: Integer): TPluto2DSprite;
begin
  result:=TPluto2DSprite(fItems[index]);
end; // TPluto2SpriteManger.GetSprit

function TPluto2SpriteManger.GetCollisionItems(
  index: Integer): TPluto2DCollisionItem;
begin
  result:=(CollisionsItems[index] as TPluto2DCollisionItem)
end; // TPluto2SpriteManger.GetCollisionItems

procedure TPluto2SpriteManger.flip;
var
  px,py,pw,ph:Integer;
begin
  Buffer.Canvas.Draw(0,0,BackupBuffer);
  px:=OutCanvas.ClipRect.Left;
  py:=OutCanvas.ClipRect.top;
  
  pw:=OutCanvas.ClipRect.Right-px;
  ph:=OutCanvas.ClipRect.Bottom-py;


  BitBlt(OutCanvas.Handle,px,py,pw,ph,Buffer.Canvas.Handle,px,py,SRCCOPY);
end; // TPluto2SpriteManger.flip

procedure TPluto2SpriteManger.DrawAllSprite(Sprite:TPluto2DSprite);
var
  i,x:Integer;
  r:TRect;
begin
  for i:=0 to fItems.count-1 do begin
    if (items[i] <> NIL) and (items[i].Visible) and (items[i].guid <> Sprite.guid) and (IntersectRect(r,sprite.GetR,Items[i].GetR)) then begin
      Items[i].DrawSprite(False);
      if Items[i].SpriteMager2.fItems.count > 0 then begin
        for x:=0 to Items[i].SpriteMager2.fItems.count-1 do begin
          Items[x].SpriteMager2.Items[x].DrawSprite(False)
        end; // for x
      end;
    end;
  end;
end;

procedure TPluto2SpriteManger.Assign(aSpriteManger:TPluto2SpriteManger);
var
  i:Integer;
begin
  fItems.Clear;
  for I:=0 to aSpriteManger.fItems.count-1 do
    fItems.Add(aSpriteManger);
end; // TPluto2SpriteManger.Assign

 // TPluto2SpriteManger.DrawAllSprite
// ----------------------------------------------
// TPluto2SpriteManger                          -
// ----------------------------------------------
constructor TPluto2SpriteManger.Create(Pluto2DEngine:TPluto2DEngine; const aUsedVisibleList:Boolean = False);
begin
  inherited Create;
  if aUsedVisibleList then begin
    fVisibleList:=TPluto2DSpriteList.Create;
    fUsedVisibleList:=True;
  end;
  
  if Pluto2DEngine <> NIL then begin
    CollisionsItems:=TObjectList.Create;
    OutCanvas:=Pluto2DEngine.OutCanvas;
    Buffer:=Pluto2DEngine.Buffer;
    BackupBuffer:=Pluto2DEngine.BackupBuffer;
    ImageList:=Pluto2DEngine.ImageList;
    fItems:=TObjectList.Create;
    fOnDraw:=@Pluto2DEngine.DrawSprits;
    Pluto2DEngine.SpriteMangerList.Add(self);
    Engine:=Pluto2DEngine;
  end; // Pluto2DEngine <> NIL
end; // TPluto2SpriteManger.Create

procedure TPluto2SpriteManger.CheckCollision;
var
  i,x:Integer;
  r1,r2,r3:TRect;
begin
  for i:=0 to fItems.count-1 do begin
    r1:=Items[i].GetR;
    for x:=0 to fItems.count-1 do begin
      if (i <> x) and {(not items[x].NoCollision) and} (not items[i].NoCollision) then begin
        r2:=Items[x].GetR;
        if IntersectRect(r3,r1,r2) then begin

      //    if Assigned(Engine.onCollision) then
        //    Engine.onCollision(items[i],items[x]);
        end;
      end;
    end;
  end;
end; // TPluto2SpriteManger.CheckCollision

procedure TPluto2SpriteManger.CheckCollision(Sprite: TPluto2DSprite; const px,py:Integer);
var
  i:Integer;
  r1,r2,r3:TRect;
  sp:TPluto2DSprite;
begin
  r1:=rect(px,py,px+sprite.Width,py+sprite.Height);

  for i:=0 to fItems.count-1 do begin
    if (items[i].name <> Sprite.name) {and (not items[i].NoCollision)} then begin
      r2:=items[i].GetR;
      if (IntersectRect(r3,r1,r2)) then begin
        sp:=items[i];
        if Assigned(Engine.onCollision) then
         Engine.onCollision(Sprite,sp);
      end;
    end;
  end;
end;

procedure TPluto2SpriteManger.CheckCollision(const ax, ay: Integer);
var
  i:Integer;
  p:TPoint;
begin
  p:=Point(ax,ay);
  
  for i:=0 to fItems.count-1 do begin
    if {(not items[i].NoCollision) and} (PtInRect(items[i].GetR,p)) and (Assigned(Engine.onCollision)) then
//      Engine.onCollision(items[i],nil);
  end;
end;

function TPluto2SpriteManger.N_Collision(const ax, ay: Integer;
  const aEvent: Boolean; const aPixelcheck: boolean): TPluto2DSprite;
var
  i:Integer;
  sp:TPluto2DSprite;
  p:TPoint;
  r1:TRect;
begin
  sp:=nil; p:=Point(ax,ay); r1:=Engine.GameFehld;
  // Schauen ob die Positions Angabe im Spielb Rect Liegt
  if (PtInRect(r1,p)) then begin
    for i:=0 to fItems.Count-1 do begin
      if PtInRect(Items[i].GetR,p) then begin
        if (not items[i].NoCollision) and (items[i].visible) then begin
          sp:=Items[i];
          //break;
        end;
      end;
    end; // for i
  end;

  if (aEvent) and (Assigned(Engine.onCollision) ) then begin
    Engine.onCollision(nil, sp);
  end;

  result:=sp;
end; // TPluto2SpriteManger.N_Collision

function TPluto2SpriteManger.N_Collision(const ax, ay:Integer; const aSprite: TPluto2DSprite;
  const aEvent: Boolean; const aPixelcheck: boolean): TPluto2DSprite;
var
  i:Integer;
  sp:TPluto2DSprite;
  p:TPoint;
  r1, r2, r3,r4,r5:TRect;
begin
  sp:=nil; p:=Point(ax,ay); r1:=Engine.GameFehld;
  r2:=Rect(ax, ay, ax+aSprite.Width, ay+aSprite.Height);
  r4:=rect(aSprite.Left,aSprite.Top,aSprite.Width,aSprite.Height);
  // Schauen ob die Positions Angabe im Spielb Rect Liegt
  if (PtInRect(r1,p)) then begin
    for i:=0 to fItems.Count-1 do begin
      if (aSprite.guid <> items[i].guid) then begin
        if IntersectRect(r3,items[i].GetR,r2) then begin
          if (not items[i].NoCollision) and (items[i].visible) then begin
            if not aPixelcheck then begin
              sp:=Items[i];
              break;
            end
            else begin
              r5:=rect(items[i].Left,items[i].Top,items[i].Width,items[i].Height);
              if kollision(r4,r5,aSprite.SpriteImage,items[i].SpriteImage) then begin
                sp:=Items[i];
                break;
              end; // if kollision(..)
            end; // else begin
          end; // if (not NoCollision)
        end; // if IntersectRect(..)
      end; // if asprite.guid <> items[i].guid
    end; // for i
  end;

  if (sp <> NIL) and (aEvent) and (Assigned(Engine.onCollision)) then begin
    Engine.onCollision(nil, sp);
  end;
  result:=sp;
end; // TPluto2SpriteManger.N_Collision

function TPluto2SpriteManger.N_GetCollision(const ax, ay: Integer;
  const aSpriteList: TPluto2DSpriteList): TPluto2DSprite;
var
  i:Integer;
  p:TPoint;
  R1:TRect;
  d,l:TPluto2DSprite;
begin
  p:=Point(ax,ay); r1:=Engine.GameFehld; d:=nil;
  if (PtInRect(r1,p)) then begin
    for i:=aSpriteList.Count-1 downto 0 do begin
      l:=aSpriteList.SpriteList[i];
      if (PtInRect(l.GetR(l.left,l.top),p)) then begin
        if (not l.NoCollision) and (l.visible) then begin
          d:=l;
          if assigned(engine.onCollision) then Engine.onCollision(l,d);
          break;
        end;
      end;
    end; // for i
    result:=d;
  end;
end; // TPluto2SpriteManger.N_GetCollision

function TPluto2SpriteManger.GetCollision(const ax, ay: Integer; sprite:TPluto2DSprite): Integer;
var
  i, z, l, a, m:Integer;
  p:TPoint;
  R1,R2,R3:TRect;
  c:Boolean;
  d:TPluto2DSprite;
begin
  p:=Point(ax,ay); z:=-1; r1:=Engine.GameFehld; c:=False;

  for i:=0 to CollisionsItems.Count-1 do begin
    if (CollisionItem[i].Enabled) then begin
      R2:=Rect(CollisionItem[i].Kompo.Left,
               CollisionItem[i].Kompo.Top,
               CollisionItem[i].Kompo.Left+CollisionItem[i].Kompo.Width,
               CollisionItem[i].Kompo.Top+CollisionItem[i].Kompo.Height);
      if (PtInRect(r2,p)) then begin
        c:=True;
        z:=FindCollisionItem(CollisionItem[i].Kompo.GUID,True);
      end;
    end;
  end; // for i

  if (z > -1) and (c) then begin
    result:=z;
  end;

  if not c then begin
    if (PtInRect(r1,p)) then begin
      for i:=0 to fItems.count-1 do begin
        if (PtInRect(items[i].GetR(items[i].left,items[i].top),p)) then begin
          if (not items[i].NoCollision) and (items[i].visible) then begin
            d:=items[i];
            if assigned(engine.onCollision) then Engine.onCollision(items[i],d);
            z:=i;
          end;
        end;
      end; // for i
      result:=z;
    end
    else
      result:=1;
  end; // if not c
end;

function TPluto2SpriteManger.FindCollisionItem(const aString: String; const aFindSpritManger:Boolean = False): Integer;
var
  i,z:Integer;
begin
  z:=-1;
  if not aFindSpritManger then begin
    for i:=0 to CollisionsItems.Count-1 do begin
      if CollisionItem[i].Kompo.GUID = aString then begin
        z:=i;
        break;
      end;
    end; // for i
  end
  else begin
    for i:=0 to fItems.Count-1 do begin
      if Items[i].guid = aString then begin
        z:=i;
        break;
      end;
    end; // for i
  end;
  result:=z;
end; // TPluto2SpriteManger.FindCollisionItem

destructor TPluto2SpriteManger.Destroy;
begin
  inherited Destroy;
end; // TPluto2SpriteManger.Destroy

function TPluto2SpriteManger.AddCollisionItems(const aSprite: TPluto2DSprite):Integer;
var
  i,z:Integer;
  CI:TPluto2DCollisionItem;
begin
  z:=FindCollisionItem(aSprite.guid);
  if z = -1 then begin
    CI:=TPluto2DCollisionItem.Create;
    CI.Kompo:=aSprite;

    CollisionsItems.add(ci);
  end; // z > -1
  result:=z;
end; // TPluto2SpriteManger.AddCollisionItems

// ----------------------------------------------
// TPluto2DSprite                               -
// ----------------------------------------------

procedure TPluto2DSprite.SetParent2(AValue: TPluto2DSprite);
var
  ps:TPluto2DSprite;
begin
  if fParent2=AValue then exit;
  ps:=AValue;
  fParent2:=AValue;
//  ps.mainParent:=self;
//  AValue.mainParent:=self;
end;

function TPluto2DSprite.GetAutoLoadId: Boolean;
begin
  result:=fAutoLoadID;
end; // TPluto2DSprite.GetAutoLoadId

function TPluto2DSprite.GetAutoDrawLoadID: Boolean;
begin
  result:=fAutoDrawLoadID;
end; // TPluto2DSprite.GetAutoDrawLoadID

procedure TPluto2DSprite.SetAutoDrawLoadID(const AValue: Boolean);
begin
  if fAutoDrawLoadID=AValue then exit;
  fAutoDrawLoadID:=AValue;
end; // TPluto2DSprite.SetAutoDrawLoadID

procedure TPluto2DSprite.SetAutoLoadID(const AValue: Boolean);
begin
  fAutoLoadID:=AValue;
end; // TPluto2DSprite.SetAutoLoadID

{function TPluto2DSprite.GetParent: TPluto2DSprite;
begin
  result:=fParent;
end; // TPluto2DSprite.GetParent

procedure TPluto2DSprite.SetParant(const AValue: TPluto2DSprite);
begin
  fparent:=AValue;
end; // TPluto2DSprite.SetParant}

function TPluto2DSprite.GetTag: Integer;
begin
  result:=ftag;
end; // TPluto2DSprite.GetTag

procedure TPluto2DSprite.SetTag(const AValue: Integer);
begin
  fTag:=aValue;
end; // TPluto2DSprite.SetTag

function TPluto2DSprite.GetBeschreibung: String;
begin
  result:=fBeschreibung;
end; // TPluto2DSprite.GetBeschreibung

function TPluto2DSprite.GetID: string;
begin
  result:=fID;
end; // TPluto2DSprite.GetID

function TPluto2DSprite.GetName: String;
begin
  result:=fName;
end; // TPluto2DSprite.GetName

function TPluto2DSprite.GetNoCollision: Boolean;
begin
  result:=fNoCollision;
end; // TPluto2DSprite.GetNoCollision

function TPluto2DSprite.GetRec(Index: integer): integer;
begin
  if index = 0 then result:=fLeft;
  if index = 1 then result:=fTop;
  if index = 2 then result:=fWidth;
  if index = 3 then result:=fHeight;
end; // TPluto2DSprite.GetRec

function TPluto2DSprite.GetTyp: String;
begin
  result:=fTyp;
end; // TPluto2DSprite.GetTyp

function TPluto2DSprite.GetVisible: Boolean;
begin
  result:=fVisible;
end; // TPluto2DSprite.GetVisible

function TPluto2DSprite.GetZusatzt: String;
begin
  result:=fZusatzt;
end; // TPluto2DSprite.GetZusatzt

procedure TPluto2DSprite.SetBeschreibung(const AValue: String);
begin
  fBeschreibung:=AValue;
end; // TPluto2DSprite.SetBeschreibung

procedure TPluto2DSprite.SetID(const AValue:String);
begin
  fID:=AValue;
  if AutoLoadID then LoadImage;
end; // TPluto2DSprite.SetID

procedure TPluto2DSprite.SetName(const AValue: String);
begin
  fName:=AValue;
end; // TPluto2DSprite.SetName

procedure TPluto2DSprite.SetNoCollision(const AValue: Boolean);
begin
  fNoCollision:=AValue;
end; // TPluto2DSprite.SetNoCollision

procedure TPluto2DSprite.SetRect(Index: integer; const AValue: integer);
begin
  case index of
    0: fLeft:=AValue;
    1: fTop:=AValue;
    2: fWidth:=AValue;
    3: fHeight:=AValue;
  end;
end; // TPluto2DSprite.SetRect

procedure TPluto2DSprite.SetTyp(const AValue: String);
begin
  fTyp:=AValue;
end; // TPluto2DSprite.SetTyp

procedure TPluto2DSprite.SetVisible(const AValue: Boolean);
  function FindObj:Integer;
  var
    i,z:Integer;
  begin
    z:=-1;
    for i:=0 to SpriteMager.fVisibleList.Count-1 do begin
      if SpriteMager.fVisibleList.SpriteList[i].guid = guid then begin
        z:=i;
        break;
      end;
    end; // for i
    result:=z;
  end;
var
  index,c:Integer;
begin
  fVisible:=AValue;

  if SpriteMager.fUsedVisibleList then begin
    if fVisible then begin
      index:=FindObj;
      if index > -1 then begin
        c:=SpriteMager.fVisibleList.Count-1;
        SpriteMager.fVisibleList.Move(index,c);
      end;
    end;
  end;
end; // TPluto2DSprite.SetVisible

procedure TPluto2DSprite.SetZusatzt(const AValue: String);
begin

end; // TPluto2DSprite.SetZusatzt

constructor TPluto2DSprite.Create(aSpriteManger:TPluto2SpriteManger);
begin
  inherited Create;
  SpBackup:=TBitMap.Create;
  guid:=RandomGUI;
  mainParent:=nil; Parent2Visible:=False; KX:=-1; ky:=-1; Parent2:=nil;
  isBackup:=False; fvisible:=True; ox:=-1; oy:=-1; ow:=-1; oh:=-1;
  NoCollision:=False;

  SpriteMager:=aSpriteManger;
  // Damit der Sprit über all zugreiff auf den SprigManger hat

  // Weist einige Standart Variabeln zu
  // OutCanvas ist der Bereich wo das ganze Sichtbar wird
  // z.b. eine Paintbox
  OutCanvas:=SpriteMager.OutCanvas;
  
  // Das OFF-Scren um Flackern zu vermeiden
  Buffer:=SpriteMager.Buffer;
  
  // Speichert das Hintergrund Bild
  BackupBuffer:=SpriteMager.BackupBuffer;

  // Damit der Sprit zugrief auf die Imageliste der
  // 2D Engine hat, wo alle verfügbaren Objekte geladen sind.
  ImageList:=SpriteMager.ImageList;

  { Fügt den Sprite dem Spritmanger zu
    ist wichtig fürs zeichnen und für die Collisions
    Funktion
  }
  SpriteMager.fItems.Add(self);

  // Wenn ein zwieter Sprite Manger benögitg wird, z.b.
  // Wenn der Sprite Kinder enhält,
  SpriteMager2:=TPluto2SpriteManger.Create(nil);
  SpriteMager2.fItems:=TObjectList.Create;
  SpriteMager2.OutCanvas:=OutCanvas;
  SpriteMager2.Buffer:=Buffer;
  SpriteMager2.BackupBuffer:=BackupBuffer;
  SpriteMager2.ImageList:=ImageList;
  SpriteMager2.fOnDraw:=@SpriteMager.DrawAllSprite;

  if SpriteMager.fUsedVisibleList then begin
    SpriteMager.fVisibleList.add(SpriteMager.fItems[SpriteMager.fItems.Count-1]);
  end; // aUsedVisibleList
end; // TPluto2DSprite.Create

constructor TPluto2DSprite.Create(achildSprite: TPluto2DSprite);
begin
  inherited Create;

  Parent:=achildSprite; NoCollision:=False; //Data:=nil;
  isBackup:=False; visible:=True; ox:=-1; oy:=-1; ow:=-1; oh:=-1;
  isBackup:=False; visible:=True; ox:=-1; oy:=-1; ow:=-1; oh:=-1;
  NoCollision:=False;

  OutCanvas:=achildSprite.OutCanvas;
  Buffer:=achildSprite.Buffer;
  BackupBuffer:=achildSprite.BackupBuffer;
  ImageList:=achildSprite.ImageList;

  achildSprite.SpriteMager2.fItems.Add(self);
end; // TPluto2DSprite.Create

destructor TPluto2DSprite.Destroy;
//var
//  i:integer;
begin
 { for i:=0 to SpriteMager.fItems.Count-1 do begin
    if SpriteMager.Items[i].guid = guid then begin
      SpriteMager.fItems.Delete(i);
      break;
    end;
  end; }
  
  SpriteMager.fItems.Remove(self);
  inherited Destroy;
  //self:=niL;
end; // TPluto2DSprite.Destroy

procedure TPluto2DSprite.Assign(var aSprite: TPluto2DSprite);
begin
  id:=asprite.id; LoadImage; Name:=asprite.name; typ:=aSprite.typ;
  Parent2:=nil;
  if (aSprite.Parent2 <> NIL) then begin
    Parent2:=TPluto2DSprite.Create(SpriteMager);
    Parent2.id:=aSprite.Parent2.id;
    Parent2.name:=aSprite.Parent2.name;
    Parent2.typ:=aSprite.Parent2.typ;
    Parent2.LoadImage;
  end;
    
  SpriteMager2.Assign(aSprite.SpriteMager2);
  aSprite.Parent2:=NIL; aSprite.Parent:=nil; aSprite.typ:='';
  aSprite.id:=''; aSprite.name:='';
end; // TPluto2DSprite.Assign

procedure TPluto2DSprite.LoadImage;
var
  ImageListItem:TPlutoImageListItem;
  i:Integer;
begin
  if id <> '' then begin
    ImageListItem:=ImageList.FindID(id);
    if ImageListItem <> NIL then begin
      SpriteImage:=TBitmap.Create;
      SpriteImage.Assign(ImageListItem.image);
      name:=ImageListItem.name;
      typ:=ImageListItem.typ;
      Width:=SpriteImage.Width;
      Height:=SpriteImage.Height;
      zusatzt:=ImageListItem.zusatzt;
      SpriteImage.Transparent:=ImageListItem.image.Transparent;
      SpriteImage.TransparentColor:=ImageListItem.image.TransparentColor;
    end
    else
      writeln('- ID wurde nicht gefunden: "', id, '" -');
  end
  else
    writeln('- ID Enhält keinen Wert -');
end; // LoadImage

procedure TPluto2DSprite.DrawSprite(const event:Boolean = True; const NewDraw:Boolean = True);
var
  x,y,i,c:Integer;
begin
  if (Parent2 <> NIL) and (Parent2Visible) then exit;
  if (Parent = nil) and (Parent2 = NIL) then begin
    x:=left; y:=top;
  end
  else begin
    if Parent <> NIL then begin
      x:=Parent.Left+left;
      y:=Parent.top+top;
    end;

    if Parent2 <> NIL then begin
      Parent2.kx:=Parent2.Left+left;
      Parent2.ky:=Parent2.top+top;
    end;
  end;

  if (isBackup) and (event) then begin
    if Parent2 <> NIL then begin
      BitBlt(Buffer.Canvas.Handle,parent2.ox,parent2.oy,parent2.ow,parent2.oh,BackupBuffer.Canvas.Handle,parent2.ox,parent2.oy,SRCCOPY);
      BitBlt(OutCanvas.Handle,parent2.ox,parent2.oy,parent2.ow,parent2.oh,Buffer.Canvas.Handle,parent2.ox,parent2.oy,SRCCOPY);
   end
   else begin
      BitBlt(Buffer.Canvas.Handle,ox,oy,ow,oh,BackupBuffer.Canvas.Handle,ox,oy,SRCCOPY);
      BitBlt(OutCanvas.Handle,ox,oy,ow,oh,Buffer.Canvas.Handle,ox,oy,SRCCOPY);
   end;
  end;

  {
    Löst bei der 2D Engine ein Event aus,
    welches bei allen SpritManger
    alle Sprits neuzeichnet bzw. nur die
    die sich im bereich befinden.

    Der Parameter Event gibt an, ob dieses
    Ereigniss ausgelöst werden soll oder nicht,
    sonst würde es eine Endlos schleife geben.
  }

  if ((Parent = nil) or (Parent2 =NIL)) and (SpriteMager <> NIL) and (Assigned(SpriteMager.fOnDraw)) and (event) then begin
    SpriteMager.fOnDraw(self);
  end
  else begin
    if Parent2 = NIL then begin
      if (Parent <> NIL) and (event) and (PtInRect(parent.getr,point(x,y))) then begin
        Parent.DrawSprite(False);
      end;
    end;
  end;

//  Wenn schon was gezeichnet wurde steht isBackup auf True
//  und löscht das Akteulel Bild im Buffer und im Outcanvas(z.b. Paintbox)
//  Zeichnet das Eigentliche Bild an der Neuen Position
  if (SpriteImage <> NIL) and (visible) then begin

    if Parent2 = NIL then begin

      Buffer.canvas.Draw(x,y,SpriteImage);
      if NewDraw then OutCanvas.Draw(x,y,SpriteImage);
    end
    else begin
      Buffer.canvas.Draw(left,top,SpriteImage);
  //    if NewDraw then
      OutCanvas.Draw(left,top,SpriteImage);
      Buffer.canvas.Draw(Parent2.kx,Parent2.ky,parent2.SpriteImage);
//      if NewDraw then
      OutCanvas.Draw(Parent2.kx,Parent2.ky,parent2.SpriteImage);
    end;

    if Parent2 = NIL then begin
      if Parent = nil then
        c:=SpriteMager2.fItems.Count
      else
        c:=0;

      if (c > 0) then begin
        for i:=0 to SpriteMager2.fItems.Count-1 do begin
          SpriteMager2.Items[i].DrawSprite(false);
        end; // for i
      end;
    end;
  end;

  if SpriteImage <> NIL then begin
    // Speichert die Gerade gezeichnete Werte und stellt IsBackup auf True
    if ((Parent2 <> NIL) and (Parent2.kx = -1)) or (Parent2 = NIL) then ox:=x;
    if ((Parent2 <> NIL) and (Parent2.kx = -1)) or (Parent2 = NIL) then oy:=y;

    if ((Parent2 <> NIL) and (Parent2.kx > -1)) then ox:=Parent2.kx;
    if ((Parent2 <> NIL) and (Parent2.kx > -1)) then oy:=Parent2.ky;

    if Parent2 <> NIL then
      ow:=Parent2.SpriteImage.Width
    else
      ow:=SpriteImage.Width;

    if Parent2 <> NIL then
      oh:=Parent2.SpriteImage.Height
    else
      oh:=SpriteImage.Height;

    isBackup:=True;
  end;
end;

procedure TPluto2DSprite.BackupImage;
begin
  BitBlt(SpBackup.Canvas.Handle,0,0,Width,Height,Buffer.Canvas.Handle,top,left,SRCCOPY);
end; // TPluto2DSprite.BackupImage

procedure TPluto2DSprite.BackupToImage;
begin
  BitBlt(Buffer.Canvas.Handle,left,top,Width,Height,SpBackup.Canvas.Handle,0,0,SRCCOPY);
  BitBlt(OutCanvas.Handle,left,top,Width,Height,SpBackup.Canvas.Handle,0,0,SRCCOPY);
end; // TPluto2DSprite.BackupToImage

function TPluto2DSprite.GetR(const nx:Integer = 0; const ny:Integer = 0; const nw:Integer = 0; const nh:Integer= 0): TRect;
var
  lx,ly,lw,lh:Integer;
begin
  lx:=ox; ly:=oy; lw:=ox+ow; lh:=oy+oh;
  
  if nx > 0 then lx:=nx;
  if ny > 0 then begin
    ly:=ny;
    lh:=ly+oh;
  end;
//  if nw = 0 then lw:=ox+ow;
  if nw >0 then lw:=nw+ow;

  //if nh = 0 then lh:=oy+oh;
  if nh >0 then lh:=nh+oh;


  result:=rect(lx,ly,lw,lh);
end; // TPluto2DSprite.GetR

// ---------------------------------------------
// TPluto2DEngineDisPlayItem
// ---------------------------------------------
constructor TPluto2DEngineDisPlayItem.Create;
begin
  fgColor:=clRed; bgColor:=clBlack; pColor:=clBlue;
  Left:=0; Top:=0; Width:=0; Height:=0; Text:='';
end; // TPluto2DEngineDisPlayItem.Create

{ TPluto2DCollisionItem }
constructor TPluto2DCollisionItem.Create;
begin
  inherited Create; Enabled:=False;
end; // TPluto2DCollisionItem.Create

destructor TPluto2DCollisionItem.Destroy;
begin
  inherited Destroy;
end; // TPluto2DCollisionItem.Destroy

// ----------------------------------
// - TPluto2DSpriteList             -
// ----------------------------------

function TPluto2DSpriteList.GetItems(index: Integer): TPluto2DSprite;
begin
  result:=(Items[index] as TPluto2DSprite)
end; // TPluto2DSpriteList.GetItems

constructor TPluto2DSpriteList.Create;
begin
  inherited Create;
end; // TPluto2DSpriteList.Create

destructor TPluto2DSpriteList.Destroy;
begin
  inherited Destroy;
end; // TPluto2DSpriteList.Destroy

end. // uPluto2dEngine
