{
  Autor: Michael Springwald

  Erstellt: Montag den 19.November.2007
  Updates:
   ----------------------------------------------------------------------
01 | Sontag, 02.Dezember.2007      | Samstag, 08.Dezember.2007          |
   ----------------------------------------------------------------------
02 | Sontag, 09.Dezember.2007      | Montag, 10.Dezember.2007           |
   ----------------------------------------------------------------------
03 | Mittwoch, 25.Dezember.2007    | Montag, 28.Janur.2008              |
   ----------------------------------------------------------------------
04 | Dienstag, 29.Janur.2008       | Freitag, 22.Febura.2008            |
   ----------------------------------------------------------------------
05 | Montag, 25.Febura.2008        |                                    |
   ----------------------------------------------------------------------
06 |                               |                                    |
   ----------------------------------------------------------------------
07 |                               |                                    |
   ----------------------------------------------------------------------
08 |                               |                                    |
   ----------------------------------------------------------------------
}

unit uPlutoImageList;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, contnrs, Graphics, LCLType, LCLIntf, uOpExt, Tools, ucolorlist,
  DOM, XMLRead
  ;

type
  tptlist = class
     list:array of TPoint;
  end;
  
  { TPlutoImageListItem }
  TPlutoImageListItem = class
  private

  protected

  public
    tag:Integer;
    image:TBitmap;
    w,h:Integer;
    FileName,id,name,typ,zusatzt:String;
    // Liste mit den Kollisions Punkten
    ptList:tptlist;
    // ist die PTlist schon geladen ?
    LoadPtList:Boolean;
    
    Tranzparent:Boolean;
    TranzparentColor:TColor;
    
    procedure CreateListe;
    constructor Create;
    destructor Destroy; override;
  published

  end; // TPlutoImageListItem

  // ------------------------------------
  // TPlutoImageList                    -
  // ------------------------------------
  TPlutoImageList = class
    function GetListItem(index: Integer): TPlutoImageListItem;
  private

  protected

  public
    Items:TObjectList;
    property images[index:Integer]:TPlutoImageListItem read GetListItem;default;
    procedure LoadImageListFromFile(const aFileName:String);
    function LoadXML(const aFileName:String; const aGrafikKlasse:String):Integer;
    function FindID(const aID:String):TPlutoImageListItem;
    constructor Create;
    destructor Destroy; override;
  published

  end; // TPlutoImageList

implementation

function TPlutoImageList.GetListItem(index: Integer): TPlutoImageListItem;
begin
  result:=TPlutoImageListItem(items[index]);
end;

procedure TPlutoImageList.LoadImageListFromFile(const aFileName:String);
var
  data:TStrings;
  i,x,j:integer;
  obj:TPlutoImageListItem;
  n,n1,pw,ph,px,py:Integer;
  str,FileName,str2:String;
  tmp:TBitMap;
  TextCaption,ids,dir:String;
  block:Boolean;
  test:TBitmap;
begin
  data:=TStringlist.Create; data.LoadFromFile(aFileName);
  tmp:=TBitMap.Create;
  dir:=ExtractFileDir(aFileName) + DirectorySeparator;

  i:=0; n1:=0; n:=0; block:=False;
  test:=TBitmap.Create;
  while i <Data.count-1 do begin
    str:=data[i];
    writeln(str);
    if (str <> '') and (str[1] <> '#') then begin
      if (str[1] = '|') then begin
        n1:=0; block:=False;
        if pos(':',str) > 0 then begin
          if Pos(',',str) = 0 then begin
            n:=StrToInt(GetToken(str,':',2))
          end
          else begin
            n:=StrToInt(GetToken(GetToken(str,':',2),',',1));
          end;
          FileName:=GetToken(GetToken(str,'|',2),':',1);

          LoadFileToBMP(dir + FileName,tmp);
          block:=True;
        end
        else begin
          block:=False;
          n:=0;
          obj:=TPlutoImageListItem.Create;
          x:=Pos('>',str);
          if x > 0 then begin
            obj.zusatzt:=copy(str,x+1,Length(str));
            Delete(str,x,Length(str));
          end;
          
          obj.FileName:=GetToken(GetToken(str,'|',2),',',1);
//          writeln();
          if pos(',',str) > 0 then begin
            obj.id:=GetToken(str,',',2);
            obj.typ:=GetToken(str,',',3);
            obj.name:=GetToken(str,',',4);
            obj.Tranzparent:=StrToBool(GetToken(str,',',5));
            obj.TranzparentColor:=String2ToColor(GetToken(str,',',6));
          end
          else begin
            obj.id:=obj.FileName;
            obj.typ:=obj.FileName;
            obj.name:=obj.FileName;
            obj.TranzparentColor:=clNone;
            obj.Tranzparent:=False;
          end;

          LoadFileToBMP(dir + obj.FileName,test);
          test.TransparentMode:=tmFixed;
          test.TransparentColor:=obj.TranzparentColor;
          test.Transparent:=obj.Tranzparent;

          obj.w:=test.Width;
          obj.h:=test.Height;
          BMPSetSize(obj.image,obj.w,obj.h);
          obj.image.Assign(test);
          Items.Add(obj);
          end;
      end; // str[1] = '|'
    end;
    i:=i+1;

    if (block) and (pos(':',data[i]) > 0) and (data[i][1] <> '#') and (data[i][1] <> '|')then begin
      str:=data[i];
      if str <> '' then begin
        obj:=TPlutoImageListItem.Create;
        x:=Pos('>',str);

        if x > 0 then begin
          obj.zusatzt:=copy(str,x+1,Length(str));
          Delete(str,x,Length(str));
        end;

        obj.FileName:=FileName;
        obj.id:=GetToken(str,':',1);
        obj.typ:=GetToken(str,':',4);
        obj.name:=GetToken(str,':',3);
        obj.Tranzparent:=StrToBool(GetToken(str,':',5));
        obj.TranzparentColor:=String2ToColor('pl_'+GetToken(str,':',6));

        str2:=GetToken(str,':',2);

        px:=StrToint(GetToken(str2,',',1));
        py:=StrToint(GetToken(str2,',',2));
        pw:=StrToint(GetToken(str2,',',3));
        ph:=StrToint(GetToken(str2,',',4));


        BMPSetSize(obj.image,pw,ph);
        BitBlt(obj.image.Canvas.Handle,
               0,
               0,
               pw,
               ph,
               tmp.Canvas.Handle,
               px*pw,
               py*ph,
               SRCCOPY
        );

          obj.image.TransparentMode:=tmFixed;
          obj.image.TransparentColor:=obj.TranzparentColor;
          obj.image.Transparent:=obj.Tranzparent;

        Items.Add(obj);
      end; // if str <> '' then
    end; // if block then
  end; // while i

// Kontroll Ausgabe !
 { for i:=0 to Items.Count-1 do begin
    obj:=TPlutoImageListItem(items[i]);
    if obj.zusatzt > '' then
      WriteLn(obj.zusatzt);
//    writeln(obj.FileName,'\',obj.name,'\',obj.id,'\',obj.typ);
  end;}

  writeln('Einträge:',items.Count-1);
  data.Free; tmp.free;
end; // TPlutoImageList.LoadImageListFromFile

function TPlutoImageList.LoadXML(const aFileName: String;const aGrafikKlasse:String): Integer;
var
  PassNode: TDOMNode;
  Doc:      TXMLDocument;
  err:Integer;
  t:Boolean;
  i,y,l,k:integer;
  str,aImageFile, aZusatzt, aName, aGruppe, aID,dir:String;
  ImageObj:TPlutoImageListItem;
  aLeft, aTop, aW, aH:Integer;
  adLeft, adTop, adW, adH,lx,ly:Integer;
  
  aTranzparent,adTranzparent:Boolean;
  aTranzparentColor,adTranzparentColor:TColor;
  Image:TBitMap;
  count:Integer;
  node,node2:TDOMNode;
  aSrc:String;
  arf,ardf:Boolean;
  procedure SetProperty(aAttribute:TDOMNode);
  begin
   if str = 'src' then aImageFile:=aAttribute.NodeValue;
   if str = 'name' then aName:=aAttribute.NodeValue;
   if str = 'gruppe' then aGruppe:=aAttribute.NodeValue;
   if str = 'zusatzt' then aZusatzt:=aAttribute.NodeValue;
   if str = 'id' then aID:=aAttribute.NodeValue;
   if str = 'tranzparent' then aTranzparent:=StrToBool(aAttribute.NodeValue);
   if str = 'tranzparentcolor' then aTranzparentColor:=String2ToColor('pl_'+aAttribute.NodeValue);
   if str = 'left' then aLeft:=StrToInt(aAttribute.NodeValue);
   if str = 'top' then aTop:=StrToInt(aAttribute.NodeValue);
   if str = 'width' then aW:=StrToInt(aAttribute.NodeValue);
   if str = 'height' then aH:=StrToInt(aAttribute.NodeValue);
   if str = 'RF' then arf:=StrToBool(aAttribute.NodeValue);
 end; // SetProperty
begin
  err:=0;
  ReadXMLFile(Doc, aFileName);
  t:=True;
  dir:=ExtractFileDir(aFileName) + DirectorySeparator;
  Image:=TBitMap.Create; aGruppe:='';
  for i:=0 to doc.DocumentElement.ChildNodes.Count-1 do begin
   str:=doc.DocumentElement.ChildNodes.Item[i].NodeName;
   if str = aGrafikKlasse then begin
     for y:=0 to doc.DocumentElement.ChildNodes.Item[i].ChildNodes.Count-1 do begin
       aImageFile:=''; aName:=''; aZusatzt:=''; aID:='';
       
       node:=doc.DocumentElement.ChildNodes.Item[i].ChildNodes[y];
       count:=node.ChildNodes.Count-1;
//       writeln(count);
       if Count = -1 then begin
         for l:=0 to node.Attributes.Length-1 do begin
           str:=LowerCase(node.Attributes[l].NodeName);
           SetProperty(node.Attributes[l]);
         end; // for l;


         if (aImageFile <> '') then begin
           ImageObj:=TPlutoImageListItem.Create;
           ImageObj.id:=aID; ImageObj.name:=aName; ImageObj.typ:=aGruppe;
           ImageObj.zusatzt:=aZusatzt; ImageObj.FileName:=aImageFile;
           ImageObj.image:=TBitMap.Create;
           LoadFileToBMP(dir + imageobj.FileName,ImageObj.image);
           if aTranzparentColor > 0 then
           ImageObj.image.TransparentColor:=aTranzparentColor;
           ImageObj.image.Transparent:=aTranzparent;
           ImageObj.image.TransparentMode:=tmFixed;
           Items.Add(ImageObj);
         end; // if
       end // if Count = -1
       else begin
         aSrc:=node.Attributes[0].NodeValue;

         node2:=node.Attributes.GetNamedItem('src');
         if node2 <> NIL then aSrc:=node2.NodeValue;

         node2:=node.Attributes.GetNamedItem('Width');
         if node2 <> NIL then adW:=StrToInt(node2.NodeValue);

         node2:=node.Attributes.GetNamedItem('Height');
         if node2 <> NIL then adH:=StrToInt(node2.NodeValue);

         node2:=node.Attributes.GetNamedItem('Tranzparent');
         if node2 <> NIL then adTranzparent:=StrToBool(node2.NodeValue);

         node2:=node.Attributes.GetNamedItem('Tranzparentcolor');
         if node2 <> NIL then adTranzparentColor:=String2ToColor('PL_'+node2.NodeValue);

         arf:=False; ardf:=False;
         node2:=node.Attributes.GetNamedItem('RF');
         if node2 <> NIL then ardf:=StrToBool(node2.NodeValue);

         LoadFileToBMP(dir + aSrc,Image);

         for k:=0 to count do begin
           node:=doc.DocumentElement.ChildNodes.Item[i].ChildNodes[y].ChildNodes[k];
           aW:=adW; ah:=adH; aTranzparentColor:=adTranzparentColor;
           aTranzparent:=adTranzparent; arf:=ardf;
           for l:=0 to node.Attributes.Length-1 do begin
             str:=LowerCase(node.Attributes[l].NodeName);
             SetProperty(node.Attributes[l]);
           end; // for l;
           if aGruppe <> '' then
           writeln(aGruppe);
           ImageObj:=TPlutoImageListItem.Create;
           ImageObj.id:=aID; ImageObj.name:=aName; ImageObj.typ:=aGruppe;
           ImageObj.zusatzt:=aZusatzt; ImageObj.FileName:=aImageFile;
           ImageObj.image:=TBitMap.Create;
           BMPSetSize(ImageObj.image,aW,aH);
           if not arf then begin
             lx:=aLeft * aW;
             ly:=aTop * aH;
           end
           else begin
             lx:=aLeft;
             ly:=aTop;
           end;
           
           BitBlt(ImageObj.image.Canvas.Handle,0,0,aw,ah,
                  Image.Canvas.Handle,lx,ly,SRCCOPY
           );
           ImageObj.image.TransparentColor:=aTranzparentColor;
           ImageObj.image.Transparent:=aTranzparent;
           ImageObj.image.TransparentMode:=tmFixed;

           Items.Add(ImageObj)
         end; // for k
       end; // else
     end; // for y
   end; // for i
  end;
  
  result:=err;
end; // TPlutoImageList.LoadXML

function TPlutoImageList.FindID(const aID: String): TPlutoImageListItem;
var
  i:Integer;
begin
  for i:=0 to items.Count-1 do begin
    if images[i].id = aId then begin
  //    if not images[i].LoadPtList then images[i].CreateListe;
      result:=images[i];
      exit;
    end;
  end;
  result:=nil;
end; // TPlutoImageList.FindID

// ------------------------------------
// TPlutoImageList                    -
// ------------------------------------
constructor TPlutoImageList.Create;
begin
  inherited Create;
  Items:=TObjectList.Create
end; // TPlutoImageList.Create

destructor TPlutoImageList.Destroy;
var
  i:Integer;
begin
  for i:=Items.Count-1 downto 0 do begin
    FreeAndNil(images[i].image);
    items.Remove(items[i]);
  end;

  inherited Destroy;
end; // TPlutoImageList.Destroy

{ TPlutoImageListItem }

procedure TPlutoImageListItem.CreateListe;
var
  x,y:Integer;
begin
  for y:=0 to image.Height do begin
    for x:=0 to image.Width do begin
      if image.Canvas.Pixels[x,y] = clBlack then begin
        SetLength(ptList.list,High(ptList.list)+2);
        ptList.list[High(ptList.list)]:=point(x,y);
      end; // if
    end; // for X
  end; // for Y
  LoadPtList:=True;
end;

constructor TPlutoImageListItem.Create;
begin
  inherited Create;
  image:=TBitmap.Create;
  ptList:=tptlist.Create;
  SetLength(ptlist.list,0); LoadPtList:=False; Tag:=0;
end; // TPlutoImageListItem.Create

destructor TPlutoImageListItem.Destroy;
begin
  FreeAndNil(Image); SetLength(ptList.list,0);
  inherited Destroy;
end; // TPlutoImageListItem.Destroy

end.

