{
  Autor: Michael Springwald

  Erstellt: Sontag, 25.November.2007
  Updates: Montag, 26.November.2007, Mittwoch, 28.November.2007
           Samstag, 01.Dezember.2007, Sontag, 02.Dezember.2007

}

unit uplutogamemenu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, contnrs, Graphics, uOpExt, LCLType, LCLIntf,IniFiles,
  ucolorlist,Tools
  ;

type
  TPlutoGameMenu = class;
  TOnMouseDown = procedure(const ax, ay:Integer; Shift:TShiftState) of Object;
  TOnMenuCommand  = procedure(const aTyp:Integer; aPageMenuIndex, aMenuIndex:Integer) of Object;
  //TOnMenuCommand2  = procedure(const aTyp:Integer; aPageMenuIndex, aMenuIndex:Integer) of Object;

// -------------------------------------------------
  { TTPlutoGameMenuItem }
// -------------------------------------------------

  { TPlutoGameMenuItem }

  TPlutoGameMenuItem = class
  private

  protected

  public
    // Wenn mehrer Spalten verwendet werden sollen
    ColumnList: array of TPlutoGameMenuItem;
    
    // Zugrief auf die Interne Liste Wegen
    // User Events wie z.b. Maus Klicks
    PlutoGameMenu:TPlutoGameMenu;
    
    // Anzeige Text
    MenuText:String;

    // Das Menu was er laden soll
    SubMenuText:String;
    
    // Hintergrund Farbe
    BGColor:TBrush;

    // Vordergrund Farbe
    FGColor:TFont;
    
    // Rand Farbe
    PNColor:TPen;
    
    Left, Top, // Wird Manuell vom User Festgelegt
    Width, Height:Integer; // Wird Automatisch Festgelegt
    W2,H2:Integer; // Wird für die Kollisions Erkennung mit der Maus Benötigt
    
    // Fallst es ein UnterMenu gibt, was Angezeigt werden soll
    GotoMenu:String;
    procedure drawItem;
    constructor Create(aPlutoGameMenu:TPlutoGameMenu);
    destructor Destroy; override;
    procedure AddColumn(const aGameMenuItem:TPlutoGameMenuItem);

  published

  end; // TPlutoGameMenuItem

  TKeyItem = record
    key:Word;
    GotoItem:String;
  end;

  { TPlutoGamePageMenu }
  TPlutoGamePageMenu = class
    function GetMenuItems(index: Integer): TPlutoGameMenuItem;
  private
  protected

  public
    // um Zugief auf TPlutoGameMenu zu haben
    GameMenu:TPlutoGameMenu;
    // Besimmt ob ein Header Angezeigt werden soll oder nicht:
    HeaderDraw:Boolean;
    HeaderCaptions:array of TPlutoGameMenuItem;
    // Bestimmt ob Spalten benutzt werden sollen
    DrawColumn:Boolean;
    
    BackupBuffer:TBitmap; // Sollte das Hintergrund Bild enthalten

    // Enahält die Anzahl der Menus ohne das - zeichen.
    MenuCount:Integer;

    // Für den Menunamen.
    MenuName:String;
    
    LoadMenu:Boolean;

    items:TObjectList;
    BackGround:String;
    MenuPos,MenuTitelPos:TPoint;
    fgColor,bgColor,pnColor:TColor;
    MenuIndex:Integer;
    MenuTitel:String;
    MenuTitelFGColor, MenuTitelbgColor, MenuTitelpnColor:TColor;
    MenuTitelSize:Integer;
    keyList2:array of Tkeyitem;
    MenuTyp:String;

    property Menus[index:Integer]:TPlutoGameMenuItem read GetMenuItems;
    procedure addKey(const aKey:Word; const aGotoItem:String);

    constructor Create(aGameMenu:TPlutoGameMenu); //override;
    destructor Destroy; override;

    procedure AddHeaderItem(const aGameMenuItem:TPlutoGameMenuItem);
    function CheckKeyMenus(const aKey:word):string;
    procedure DrawHeader(const aIndex:Integer = -1);
  published

  end; // TPlutoGamePageMenu

// -------------------------------------------------
  { TPlutoGameMenu }
// -------------------------------------------------
  TPlutoGameMenu = class
  private
    fCurrPageIndex: Integer;
    fMouseDown: TOnMouseDown;
    fOnMenuCommand:TOnMenuCommand;
    fOnMenuCommand2:TOnMenuCommand;

    procedure MenuCommand(const aTyp:Integer; aPageMenuIndex, aMenuIndex:Integer);
    function GetGamePageMenu(index: Integer): TPlutoGamePageMenu;
    procedure SetCurrPageIndex(const AValue: Integer);
  protected

  public

    fMenuFile:String;
    // Enhlät all MenuItems einer Seite
    MenuItems:TObjectList;
    property Pages[index:Integer]:TPlutoGamePageMenu read GetGamePageMenu;
    property onMouseDown:TOnMouseDown read fMouseDown write FMouseDown;
    // Die Aktuelle Menu Seite, die Gerade anezeigt wird
    property CurrPageIndex:Integer read fCurrPageIndex write SetCurrPageIndex;

    // Der Offscrennbuffer
    Buffer:TBitMap; // Ein Zustälicher Backupbuffer.

    // Der Anzeige Bildschrim
    OutCanvas:TCanvas;
    
    // Verabeitet das MouseDown Ereigniss
    procedure MouseDown(const ax,ay:Integer; Shift:TShiftState);
    
    // Verarbeitet Tastertur Ereignisse
    procedure KeyDown(const key:Word; shift:TShiftState);

    // Lädt das Angebene Menu und Setzt den entsprechenden Index
    procedure LoadMenu(const aMenuCaption:String; const aMenuFile:String ;const aAutoIndex:Boolean);

    // Zeichnet das Aktuell Menu
    procedure DrawCurrMenu;
    
    // Findet die Höste Zeile aus den Menus rauß
    function GetMenuHigY:Integer;
    
    // Findet den Breites Text aus den Menus rauß
    function GetMenuHigW:Integer;
    
    // Gibt den Angekickten Menueintrag zurück
    function GetMenuItemIndex(const ax,ay:Integer):Integer;
    
    // Zeichnet den Aktuellen Markiers Balken
    procedure SetItemIndex(const aTyp:Integer; aMenuIndex:Integer; const Sel:Boolean = False);
    
    // Filtern alle - raus
    function GetTotalItems:Integer;
    function findMenuTitel(const aTitle:String):Integer;
    constructor Create;
    destructor Destroy; override;
  published
    property onCommand:TOnMenuCommand read fOnMenuCommand2 write fOnMenuCommand2;

  end; // TPlutoGameMenu

implementation

// -------------------------------------------------

function TPlutoGameMenu.GetGamePageMenu(index: Integer): TPlutoGamePageMenu;
begin
  if MenuItems[index] is TPlutoGamePageMenu then
    result:=TPlutoGamePageMenu(MenuItems[index])
  else
    result:=nil;
end; // TPlutoGameMenu.GetGamePageMenu

procedure TPlutoGameMenu.SetCurrPageIndex(const AValue: Integer);
begin
  if fCurrPageIndex=AValue then exit;
  fCurrPageIndex:=AValue;
end; // TPlutoGameMenu.SetCurrPageIndex

procedure TPlutoGameMenu.MenuCommand(const aTyp: Integer; aPageMenuIndex,
  aMenuIndex: Integer);
var
  str:String;
begin
  //Writeln('Menuindex:',aMenuIndex);
  CurrPageIndex:=aPageMenuIndex;
  if (CurrPageIndex > -1) and (aMenuindex > -1) and (Pages[CurrPageIndex].items.count-1 >=aMenuIndex) then begin
    str:=Pages[CurrPageIndex].Menus[aMenuIndex].SubMenuText;
    if str <> '' then begin
      CurrPageIndex:=findMenuTitel(str);

      if CurrPageIndex = -1 then
        LoadMenu(str,fMenuFile,true);

      if CurrPageIndex > -1 then DrawCurrMenu;
    end
    else begin
      if assigned(fOnMenuCommand2) then fOnMenuCommand2(atyp, aPageMenuIndex,aMenuIndex);
    end
  end; // CurrPageIndex;
end; // TPlutoGameMenu.MenuCommand

procedure TPlutoGameMenu.MouseDown(const ax, ay: Integer; Shift: TShiftState);
var
  r:TRect;
  t:Integer;
begin
  r.left:=Pages[CurrPageIndex].MenuPos.x;
  r.top:=Pages[CurrPageIndex].MenuPos.y;
  r.Right:=r.left+GetMenuHigW;
  r.Bottom:=r.top+(GetMenuHigY*Pages[CurrPageIndex].items.count-1);
//  writeln(r.left,'\',r.top,'\',r.Right,'\');

  if PtInRect(r,point(ax,ay)) then begin
    t:=GetMenuItemIndex(ax,ay);

    if Pages[CurrPageIndex].MenuIndex > -1 then
      SetItemIndex(0,Pages[CurrPageIndex].MenuIndex);

    if t > -1 then
//      writeln(Pages[CurrPageIndex].Menus[t].MenuText);
      SetItemIndex(0,t,true);
  end;
end;

procedure TPlutoGameMenu.KeyDown(const key: Word; shift: TShiftState);
function GetUpPrevLine(const aIndex:Integer):Integer;
var
  i,z:Integer;
begin
  z:=aIndex;
  for i:=aIndex downto 0 do begin
    if Pages[CurrPageIndex].Menus[i].MenuText <> '-' then begin
      z:=i;
      break;
    end;
  end;
  result:=z;
end;

function GetUpNextLine(const aIndex:Integer):Integer;
var
  i,z:Integer;
begin
  z:=aIndex;
  for i:=aIndex to pages[CurrPageIndex].items.count-1 do begin
    if Pages[CurrPageIndex].Menus[i].MenuText <> '-' then begin
      z:=i;
      break;
    end;
  end;
  result:=z;
end;

var
  str:String;
  k:Integer;
begin
  if CurrPageIndex > -1 then begin
    str:=Pages[CurrPageIndex].CheckKeyMenus(key);
    if ([ssCtrl] = Shift)  then begin
      if (str <> '') then begin
       CurrPageIndex:=findMenuTitel(str);
        if CurrPageIndex = -1 then
          LoadMenu(str,fMenuFile,true);
        DrawCurrMenu;
      end
      else begin
        if assigned(fOnMenuCommand2) then
          fOnMenuCommand2(0, CurrPageIndex,pages[CurrPageIndex].MenuIndex);
      end;
    end;

    
    if KEY = VK_UP then begin
      if Pages[CurrPageIndex].MenuIndex-1 >= 0 then begin
        if Pages[CurrPageIndex].MenuIndex > -1 then
          SetItemIndex(1,Pages[CurrPageIndex].MenuIndex,False);
        
        k:=GetUpPrevLine(Pages[CurrPageIndex].MenuIndex-1);
        SetItemIndex(1,k,True);
      end
      else begin
        SetItemIndex(1,Pages[CurrPageIndex].MenuIndex);
        SetItemIndex(1,Pages[CurrPageIndex].items.count-1,True);
      end;
    end; // VK_UP
    
    if KEY = VK_DOWN then begin
      if Pages[CurrPageIndex].MenuIndex+1 <= Pages[CurrPageIndex].items.count-1 then begin
        if Pages[CurrPageIndex].MenuIndex > -1 then
          SetItemIndex(1,Pages[CurrPageIndex].MenuIndex,False);

        k:=GetUpNextLine(Pages[CurrPageIndex].MenuIndex+1);
        SetItemIndex(1,k,True);
      end
      else begin
        SetItemIndex(1,Pages[CurrPageIndex].MenuIndex);
        SetItemIndex(1,0,True);
      end;
    end; // VK_DOWN
    
    if (key = VK_RETURN) or (key = VK_SPACE) then
      SetItemIndex(0,Pages[CurrPageIndex].MenuIndex,true);
  end; // CurrPageIndex;
end;

procedure TPlutoGameMenu.LoadMenu(const aMenuCaption: String; const aMenuFile:String;
  const aAutoIndex: Boolean);
var
  iniFile:TIniFile;
  PageMenu:TPlutoGamePageMenu;
  MenuItem,HeaderItem:TPlutoGameMenuItem;
  i,c,x,hi,hii:Integer;
  px,py,pw,ph,mx,my,l,t:Integer;
  str,str1:String;
  headerfgColor:TColor;
  cr:char;
begin
  fMenuFile:=aMenuFile;
  
  iniFile:=TIniFile.Create(aMenuFile);
  PageMenu:=TPlutoGamePageMenu.Create(self);
  with iniFile do begin
    PageMenu.BackGround:=ReadString(aMenuCaption,'MenuBackGrund','');
    PageMenu.MenuName:=aMenuCaption;

    str:=ReadString(aMenuCaption,'MenuPos','');
    PageMenu.MenuPos.x:=StrToInt(GetToken(str,',',1));
    PageMenu.MenuPos.Y:=StrToInt(GetToken(str,',',2));

    str:=ReadString(aMenuCaption,'MenuTitelPos','');
    PageMenu.MenuTitelPos.x:=StrToInt(GetToken(str,',',1));
    PageMenu.MenuTitelPos.Y:=StrToInt(GetToken(str,',',2));
    
    PageMenu.MenuTitel:=ReadString(aMenuCaption,'MenuTitel','');
    PageMenu.fgColor:=String2ToColor('PL_' + ReadString(aMenuCaption,'MenuFGColor',''));
    PageMenu.bgColor:=String2ToColor('PL_' + ReadString(aMenuCaption,'MenuBGColor',''));
    PageMenu.pnColor:=String2ToColor('PL_' + ReadString(aMenuCaption,'MenuPNColor',''));
    PageMenu.MenuTyp:=ReadString(aMenuCaption,'MenuTyp','');
    PageMenu.MenuTitelFGColor:=String2ToColor('PL_' + ReadString(aMenuCaption,'MenuTitelFGColor',''));
    PageMenu.MenuTitelbgColor:=String2ToColor('PL_' + ReadString(aMenuCaption,'MenuTitelBGColor',''));
    PageMenu.MenuTitelpnColor:=String2ToColor('PL_' + ReadString(aMenuCaption,'MenuTitelPNColor',''));
    PageMenu.MenuTitelSize:=ReadInteger(aMenuCaption,'MenuTitelSize',12);

    if PageMenu.MenuTyp = 'ListViewStatic' then begin
      headerfgColor:=String2ToColor('PL_' + ReadString(aMenuCaption,'HeaderFGColor',''));
      hi:=ReadInteger(aMenuCaption,'HeaderListCount',-1);
      if hi > -1 then begin
        for i:=0 to hi do begin
          HeaderItem:=TPlutoGameMenuItem.Create(self);

          str:=ReadString(aMenuCaption,'HItem'+IntTostr(i),'');
          HeaderItem.MenuText:=GetToken(str,'|',1);
          HeaderItem.Width:=StrToInt(GetToken(str,'|',2));
          HeaderItem.FGColor.Color:=headerfgColor;
          HeaderItem.BGColor.Color:=PageMenu.bgColor;
          HeaderItem.PNColor.Color:=PageMenu.pnColor;
          PageMenu.AddHeaderItem(HeaderItem);
        end;
      end;
    end;
    
    c:=ReadInteger(aMenuCaption,'MenuCount',-1);
    if c > -1 then begin
      for i:=0 to c do begin
        MenuItem:=TPlutoGameMenuItem.Create(self);
        str1:=ReadString(aMenuCaption,'MenuItem'+IntTostr(i),'');

        if PageMenu.MenuTyp <> 'ListViewStatic' then begin
          if Pos('|',str1) = 0 then
            MenuItem.MenuText:=str1
          else begin
            MenuItem.MenuText:=GetToken(str1,'|',1);
            MenuItem.SubMenuText:=GetToken(str1,'|',2);
          end;

          l:=pos('&',str1);
          if l > 0 then begin
            cr:=copy(str1,l+1,l)[1];
            PageMenu.addKey(ord(cr),MenuItem.SubMenuText);
          end;
        end
        else begin
          str:=ReadString(aMenuCaption,'MenuItem'+IntTostr(i),'');
          for hii:=1 to hi+1 do begin
            HeaderItem:=TPlutoGameMenuItem.Create(self);
            HeaderItem.MenuText:=GetToken(str,'|',hii);
            HeaderItem.FGColor.Color:=PageMenu.fgColor;
            HeaderItem.BGColor.Color:=PageMenu.bgColor;
            HeaderItem.PNColor.Color:=PageMenu.pnColor;
            Menuitem.AddColumn(HeaderItem);
          end;

          for hii:=0 to High(Menuitem.ColumnList) do begin
            writeln(Menuitem.ColumnList[hii].MenuText);
          end; // for x

        end;
        MenuItem.FGColor.Color:=PageMenu.fgColor;
        MenuItem.BGColor.Color:=PageMenu.bgColor;
        MenuItem.PNColor.Color:=PageMenu.pnColor;
        PageMenu.LoadMenu:=True;
        PageMenu.items.Add(MenuItem);
      end; // for i
      MenuItems.Add(PageMenu);
//      writeln(PageMenu.items.count);

    end; // if c > -1
  end; // with iniFile
  iniFile.Free;
  
  //if aAutoIndex then
  CurrPageIndex:=MenuItems.Count-1;
  pages[CurrPageIndex].MenuCount:=GetTotalItems;
  
  LoadFileToBMP(PageMenu.BackGround,pages[CurrPageIndex].BackupBuffer);
  px:=Pages[CurrPageIndex].MenuPos.x;
  py:=Pages[CurrPageIndex].MenuPos.y;
  ph:=GetMenuHigY; pw:=GetMenuHigW;
  Buffer.Canvas.Font.color:=Pages[CurrPageIndex].MenuTitelFGColor;
  Buffer.Canvas.Font.Size:=Pages[CurrPageIndex].MenuTitelSize;
  t:=Buffer.Canvas.TextWidth(Pages[CurrPageIndex].MenuTitel);
  if t > pw then pw:=t;

  if PageMenu.MenuTyp <> 'ListViewStatic' then begin
    DrawTranzParentRect(pages[CurrPageIndex].BackupBuffer,rect(px,py,pw,ph*Pages[CurrPageIndex].MenuCount),Pages[CurrPageIndex].bgColor,150);

    mx:=Pages[CurrPageIndex].MenuTitelPos.x;
    my:=Pages[CurrPageIndex].MenuTitelPos.y;
    Buffer.Canvas.Font.Size:=10;

    ph:=buffer.Canvas.TextHeight(Pages[CurrPageIndex].MenuTitel)+5;
    DrawTranzParentRect(pages[CurrPageIndex].BackupBuffer,rect(mx,my,pw,ph),Pages[CurrPageIndex].MenuTitelbgColor,150);
  end
  else begin
    mx:=0;
    my:=20;
    pw:=pages[CurrPageIndex].BackupBuffer.Width;
    ph:=20;
    DrawTranzParentRect(pages[CurrPageIndex].BackupBuffer,rect(mx,my,pw,ph),clRed,150);

    mx:=0;
    my:=40;
    pw:=pages[CurrPageIndex].BackupBuffer.Width;
    ph:=pages[CurrPageIndex].BackupBuffer.Height-250;
    DrawTranzParentRect(pages[CurrPageIndex].BackupBuffer,rect(mx,my,pw,ph),pl_orange,100);

    mx:=0;
    my:=my+ph;
    pw:=pages[CurrPageIndex].BackupBuffer.Width;
    ph:=pages[CurrPageIndex].BackupBuffer.Height-ph;
    DrawTranzParentRect(pages[CurrPageIndex].BackupBuffer,rect(mx,my,pw,ph),clLime,140);
  end;
end; // TPlutoGameMenu.LoadMenu

procedure TPlutoGameMenu.DrawCurrMenu;
var
  i:Integer;
  px,py,pw,ph,ax,t:Integer;
  mx,my:Integer;
  str:widestring;
  start:Boolean;
begin
  buffer.Canvas.Draw(0,0,pages[CurrPageIndex].BackupBuffer);
//  writeln('CurrPageIndex:',CurrPageIndex);
//  writeln('Anzahl:',Pages[CurrPageIndex].items.Count-1);
  px:=Pages[CurrPageIndex].MenuPos.x;
  py:=Pages[CurrPageIndex].MenuPos.y;
  mx:=Pages[CurrPageIndex].MenuTitelPos.x;
  my:=Pages[CurrPageIndex].MenuTitelPos.y;
  ph:=GetMenuHigY;
  pw:=GetMenuHigW;
  Buffer.Canvas.Font.color:=Pages[CurrPageIndex].MenuTitelFGColor;
  Buffer.Canvas.Font.Size:=Pages[CurrPageIndex].MenuTitelSize;
  buffer.canvas.TextOut(mx,my,Pages[CurrPageIndex].MenuTitel);
  Pages[CurrPageIndex].DrawHeader;

{  t:=Buffer.Canvas.TextWidth(Pages[CurrPageIndex].MenuTitel);
  if t > pw then pw:=t;

  Buffer.Canvas.Font.Size:=10;

  for i:=0 to Pages[CurrPageIndex].items.Count-1 do begin
    str:=Pages[CurrPageIndex].Menus[i].MenuText;
    Pages[CurrPageIndex].Menus[i].Left:=px;
    Pages[CurrPageIndex].Menus[i].Top:=py;
    Pages[CurrPageIndex].Menus[i].Width:=pw;
    Pages[CurrPageIndex].Menus[i].Height:=ph;
    Buffer.Canvas.Brush.color:=Pages[CurrPageIndex].bgColor;
    Buffer.Canvas.Font.color:=Pages[CurrPageIndex].fgColor;
    Buffer.Canvas.Pen.color:=Pages[CurrPageIndex].pnColor;
    
    if str = '-' then begin
      Buffer.Canvas.MoveTo(px,py);
      Buffer.Canvas.LineTo(px+pw,py);
//      py:=py+ph;
    end
    else begin
      start:=False;
      for ax:=1 to Length(str) do begin
        if str[ax] <> '&' then begin
          if start then
            buffer.canvas.Font.color:=clred
          else
            buffer.canvas.Font.color:=Pages[CurrPageIndex].fgColor;
          Buffer.Canvas.TextOut(px,py,str[ax]);
          start:=False;
        end
        else begin
          start:=True;
        end;

        px:=px+buffer.Canvas.TextWidth(str[ax]);
      end;
      px:=Pages[CurrPageIndex].MenuPos.x;
      py:=py+ph;
    end;
//    writeln(Pages[CurrPageIndex].Menus[i].MenuText);
  end; // for i}

  if outCanvas <> NIL then
    OutCanvas.Draw(0,0,Buffer);
end; // TPlutoGameMenu.DrawCurrMenu

function TPlutoGameMenu.GetMenuHigY: Integer;
var
  i:Integer;
  z,ph:Integer;
  str:widestring;
begin
//  buffer.Canvas.Draw(0,0,pages[CurrPageIndex].BackupBuffer);
  z:=0; ph:=0;
  for i:=0 to Pages[CurrPageIndex].items.Count-1 do begin
    str:=Pages[CurrPageIndex].Menus[i].MenuText;
    Buffer.Canvas.Brush.color:=Pages[CurrPageIndex].bgColor;
    Buffer.Canvas.Font.color:=Pages[CurrPageIndex].fgColor;
    Buffer.Canvas.Pen.color:=Pages[CurrPageIndex].pnColor;
    ph:=Buffer.Canvas.TextHeight(str);

    if ph > z then z:=ph+5;
  end; // for i
  result:=z;
end; // TPlutoGameMenu.GetMenuHigY: Integer

function TPlutoGameMenu.GetMenuHigW: Integer;
var
  i:Integer;
  z,ph:Integer;
  str:widestring;
begin
//  buffer.Canvas.Draw(0,0,BackupBuffer);
  z:=0; ph:=0;
  for i:=0 to Pages[CurrPageIndex].items.Count-1 do begin
    str:=Pages[CurrPageIndex].Menus[i].MenuText;
    Buffer.Canvas.Brush.color:=Pages[CurrPageIndex].bgColor;
    Buffer.Canvas.Font.color:=Pages[CurrPageIndex].fgColor;
    Buffer.Canvas.Pen.color:=Pages[CurrPageIndex].pnColor;
    ph:=Buffer.Canvas.TextWidth(str);
    if ph > z then z:=ph+5;
  end; // for i
  result:=z;
end; // TPlutoGameMenu.GetMenuHigW

function TPlutoGameMenu.GetMenuItemIndex(const ax, ay: Integer): Integer;
var
  i,c,z:Integer;
  r:TRect;
  p:TPoint;
begin
  c:=Pages[CurrPageIndex].items.Count-1;
  z:=-1; p:=Point(ax,ay);
  for i:=0 to c do begin
  //  if Pages[CurrPageIndex].Menus[i].MenuText <> '-' then begin
      r.left:=Pages[CurrPageIndex].Menus[i].Left;
      r.top:=Pages[CurrPageIndex].Menus[i].Top;
      r.right:=r.left+Pages[CurrPageIndex].Menus[i].Width;
      r.bottom:=r.top+Pages[CurrPageIndex].Menus[i].Height;
      if PtInRect(r,p) then begin
        z:=i;
      //  break;
      end;
    //end;
  end;
  result:=z;
end;

procedure TPlutoGameMenu.SetItemIndex(const aTyp:Integer; aMenuIndex:Integer; const Sel:Boolean = False);
var
  px,py,pw,ph,ax:Integer;
  start:Boolean;
  str:String;
begin
  Pages[CurrPageIndex].MenuIndex:=aMenuIndex;
  px:=Pages[CurrPageIndex].Menus[aMenuIndex].Left;
  py:=Pages[CurrPageIndex].Menus[aMenuIndex].Top+1;
  pw:=Pages[CurrPageIndex].Menus[aMenuIndex].Width;
  ph:=Pages[CurrPageIndex].Menus[aMenuIndex].Height-1;

  // Den Alten Bereich überschreiben
  BitBlt(buffer.Canvas.Handle,px,py,pw,ph,pages[CurrPageIndex].BackupBuffer.Canvas.Handle,px,py,SRCCOPY);
  if Sel then begin
    buffer.canvas.Font.color:=clYellow;
    buffer.canvas.brush.Color:=clBlack;
    buffer.canvas.pen.color:=clRed;
    buffer.canvas.FillRect(px,py,px+pw,(py+ph));
  end
  else begin
    buffer.canvas.Font.color:=Pages[CurrPageIndex].FGColor;
  end;

  start:=False;
  str:=Pages[CurrPageIndex].Menus[aMenuIndex].MenuText;
  for ax:=1 to Length(str) do begin
    if str[ax] <> '&' then begin
      if start then
        buffer.canvas.Font.color:=clred
      else
        buffer.canvas.Font.color:=Pages[CurrPageIndex].fgColor;
      Buffer.Canvas.TextOut(px,py,str[ax]);
      start:=False;
    end
    else begin
      start:=True;
    end;
    px:=px+buffer.Canvas.TextWidth(str[ax]);
  end; // for ax
  px:=Pages[CurrPageIndex].Menus[aMenuIndex].Left;

  // Änderungen Sichtbar machen
  BitBlt(OutCanvas.Handle,px,py,pw,ph,Buffer.Canvas.Handle,px,py,SRCCOPY);

  if (atyp = 0) and (Assigned(fOnMenuCommand)) and (sel) then fOnMenuCommand(atyp,CurrPageIndex,aMenuIndex);
end; // TPlutoGameMenu.SetItemIndex

function TPlutoGameMenu.GetTotalItems: Integer;
var
  i,z:Integer;
begin
  z:=0;
  for i:=0 to Pages[CurrPageIndex].items.count-1 do begin
    if Pages[CurrPageIndex].Menus[i].MenuText <> '-' then
      inc(z);
  end;
  result:=z;
end;

function TPlutoGameMenu.findMenuTitel(const aTitle: String): Integer;
var
  i,z:Integer;
begin
  z:=-1;
  for i:=0 to MenuItems.Count-1 do begin
    if Pages[i].MenuName = aTitle then begin
      z:=i;
      break;
    end;
  end;
  result:=z;
end;

// -------------------------------------------------
{ TPlutoGameMenu }
// -------------------------------------------------
constructor TPlutoGameMenu.Create;
begin
  inherited Create;
  fOnMenuCommand2:=nil;
  Buffer:=TBitMap.Create;
  MenuItems:=TObjectList.Create;
  fOnMenuCommand:=@MenuCommand; fMenuFile:='';
end; // TPlutoGameMenu.Create

destructor TPlutoGameMenu.Destroy;
begin
  Buffer.Destroy; MenuItems.Clear; MenuItems.Destroy;
  inherited Destroy;
end; // TPlutoGameMenu.Destroy

procedure TPlutoGameMenuItem.drawItem;
begin

end; // TPlutoGameMenuItem.drawItem

// -------------------------------------------------
{ TPlutoGameMenuItem }
// -------------------------------------------------
constructor TPlutoGameMenuItem.Create(aPlutoGameMenu:TPlutoGameMenu);
begin
  inherited Create;
  SetLength(ColumnList,0);
  PlutoGameMenu:=aPlutoGameMenu;
  BGColor:=TBrush.Create; FGColor:=TFont.Create; PNColor:=TPen.Create;
end; // TPlutoGameMenuItem.Create

destructor TPlutoGameMenuItem.Destroy;
begin
  inherited Destroy;
end; // TPlutoGameMenuItem.Destroy

procedure TPlutoGameMenuItem.AddColumn(
  const aGameMenuItem: TPlutoGameMenuItem);
begin
  SetLength(ColumnList,high(ColumnList)+2);
  ColumnList[high(ColumnList)]:=aGameMenuItem;
end; // TPlutoGameMenuItem.AddColumn

function TPlutoGamePageMenu.GetMenuItems(index: Integer): TPlutoGameMenuItem;
begin
  if items[index] is TPlutoGameMenuItem then
    result:=TPlutoGameMenuItem(items[index])
  else
    result:=nil;
end; // TPlutoGamePageMenu.GetMenuItems

procedure TPlutoGamePageMenu.addKey(const aKey: Word; const aGotoItem:String);
var
  keyitem:TKeyItem;
begin
  SetLength(keyList2,Length(keyList2)+1);
  keyitem.key:=akey; keyitem.GotoItem:=aGotoItem;
  
  keyList2[High(keyList2)]:=keyitem;
end;

function TPlutoGamePageMenu.CheckKeyMenus(const aKey: word):string;
var
  i:Integer;
  str:String;
begin
  str:='';
  for i:=0 to High(keylist2) do begin
    if keyList2[i].key = aKey then begin
      str:=keyList2[i].GotoItem;
      break;
    end;
  end;
  result:=str;
end;

// -------------------------------------------------
{ TPlutoGamePageMenu }
// -------------------------------------------------
constructor TPlutoGamePageMenu.Create(aGameMenu:TPlutoGameMenu);
begin
  inherited Create;
  GameMenu:=aGameMenu;
  SetLength(HeaderCaptions,0);
  items:=TObjectList.Create;
  MenuIndex:=0; BackupBuffer:=TBitmap.Create;
end; // TPlutoGamePageMenu.Create;

destructor TPlutoGamePageMenu.Destroy;
begin
  BackupBuffer.Destroy;
  inherited Destroy;
end; // TPlutoGamePageMenu.Destroy;

procedure TPlutoGamePageMenu.AddHeaderItem(
  const aGameMenuItem: TPlutoGameMenuItem);
begin
  SetLength(HeaderCaptions,high(HeaderCaptions)+2);
  HeaderCaptions[high(HeaderCaptions)]:=aGameMenuItem;

//  writeln(HeaderCaptions[high(HeaderCaptions)].MenuText);
end;

procedure TPlutoGamePageMenu.DrawHeader(const aIndex:Integer = -1);
var
  i,x:Integer;
  px,py,pw,ph:Integer;
  procedure SetPropValues;
  begin
    GameMenu.Buffer.Canvas.Font.color:=HeaderCaptions[i].fgColor.color;
    GameMenu.Buffer.Canvas.Brush.Color:=HeaderCaptions[i].bgColor.color;
    GameMenu.Buffer.Canvas.Pen.Color:=HeaderCaptions[i].pnColor.color;
  end;

  procedure SetPropValues2;
  begin
    GameMenu.Buffer.Canvas.Font.color:=menus[i].ColumnList[x].fgColor.color;
//    GameMenu.Buffer.Canvas.Brush.Color:=HeaderCaptions[i].bgColor.color;
//    GameMenu.Buffer.Canvas.Pen.Color:=HeaderCaptions[i].pnColor.color;
  end;

begin
  px:=0; py:=MenuTitelPos.Y+20;
  for i:=0 to high(HeaderCaptions) do begin
    SetPropValues;
    pw:=HeaderCaptions[i].Width+5;
    ph:=GameMenu.Buffer.Canvas.TextHeight(HeaderCaptions[i].MenuText)+5;
    GameMenu.Buffer.Canvas.TextOut(px,py,HeaderCaptions[i].MenuText);
    px:=px+pw;
  end; // i

  px:=0; py:=MenuTitelPos.Y+50;
  GameMenu.Buffer.Canvas.Font.Size:=10;
  for i:=0 to items.count-1 do begin
    px:=0;
    for x:=0 to High(Menus[i].ColumnList) do begin
      SetPropValues2;
      pw:=HeaderCaptions[x].Width+5;
      ph:=GameMenu.Buffer.Canvas.TextHeight(Menus[i].ColumnList[x].MenuText)+5;
      GameMenu.Buffer.Canvas.TextOut(px,py,Menus[i].ColumnList[x].MenuText);
      px:=px+pw;
    end; // for x
    //if i = 0 then break;
    py:=py+ph;
  end; // i

  GameMenu.OutCanvas.Draw(0,0,gamemenu.Buffer);
end; // TPlutoGamePageMenu.DrawHeader

end.

